function out=comp_force_algo1_pca(calmat, activity)
% compute the Force corresponding to a given neural activity

%_____________________________________________
% load transformation matrix from calibration
%_____________________________________________
nStim=calmat.nStim;
ScaleMatrix=calmat.ScaleMatrix;
invPHI=calmat.invPHI;
MeanD=calmat.MeanD;
meanData=calmat.meanData;

%_____________________________________________
% derive Force from the neural activity
%_____________________________________________
tmp = repmat(activity, [1, 1, nStim]);
F = squeeze(sum(sum(meanData.*tmp,1),2));
Force=ScaleMatrix*(invPHI*F - MeanD');

out.Force=Force;