function DtrAllTest=compDtrAllTest(calmat,ntrials,opts,data)

% save it on drive. If already on drive, load it. This is to save time when
% trying different versions of the new BMI algo.

[dirName, fileName] = file_opts_REPOSITORY(opts, 'DtrAllTest');
existinhdd=exist(fullfile(dirName, [fileName '.mat']),'file')==2;

if existinhdd
    load(fullfile(dirName, fileName));

else

    nStim=calmat.nStim;
    maxTrial=calmat.nTrial;
    nUnit=calmat.nUnit;
    nT=calmat.nT;
    
    DtrAllTest=nan(nStim,max(ntrials),nStim,maxTrial);
    for kk = 1:nStim
        for ii=1:ntrials(kk)
            activity = zeros(nT, nUnit);    % needed in case nT == 1
            activity(:,:) = squeeze(data(:,ii,:,kk));
            DtrAllTest(kk,ii,:,:)=compDistTrial2Calib(calmat, activity);
        end;
    end;
    
    save(fullfile(dirName, fileName), 'DtrAllTest');
end;