function sp = MBF(t,s)
% function MBF describes the behavior of a point mass under the effect of a force in a viscous medium
%
% t: time vector
% s: state vector
%
% sp: new state vector

global ExternalForce Mass Damping % parameters to be shared with runSimulation

IM = inv(Mass);

a = -IM*(Damping*[s(3) s(4)]'+ ExternalForce);
sp(1) = s(3);
sp(2) = s(4);
sp(3) = a(1);
sp(4) = a(2);
sp = sp';
