function [Cons, Cone] = control(q)
%   [Cons, Cone] = control(s, t)
%   Control fuction 
%   Inputs
%       s = state s(1)=q1 s(2)=q2 s(3)=q1_dot s(4)=q2_dot
%       t = time
%   Outputs
%       Cons = output control torque at shoulder
%       Cone = output control torque at elbow
%   ----------------------------------

global ExternalForce % parameters to be shared with runSimulation

J=Jacobian(q);

tau=J'*ExternalForce;

Cons=tau(1);
Cone=tau(2);
