%   matlab script
%   initParams. Init  global variables, paramters, and COMPOSITE VARIABLES
%   MKS units  

    fprintf('Setting paramters..'); 
    global L Lc M I;                            % Segment parameters
    global DAMP;
    global OFFY;
    global M2L1L2_2 I2M2L2 I22 I1I2ML M2L1L2;   % Composite variables
    global flag_inv f;                          % Flag variables
    global T_init tau_thresh res;               % Optimization variables
    global accuracy;                            % Mass estimation accuracy
    global xd qd taud td;                       % Position / Joint angles & velocities / Torque / Time trajectories
    global ARMGRAPH;                            % Plotting animations
    
%   Segment parameters -----------------------
    L  = [75; 75];                            % link lengths
    Lc = .75 * L;                               % COM (75% of length)    
    M = 100*[0.8; 0.8];                             % link masses
    I = 100*[0.2; 0.2];                             % link inertias
    OFFY = 50.0;
    DAMP=[-10.0 0; 0 -10.0];

%   Composite variables ----------------------    
    M2L1L2_2=M(2)*L(1)*L(2)/2;                  % precaluated items for use later
    I2M2L2=I(2)+M(2)*L(2)^2/4; 

    %I12 = I2 + M2*L2^2/4;  Check this 
    I1I2ML = I(1) + I(2) + (M(1)*L(1)^2 + M(2)*L(2)^2)/4 + M(2)*L(1)^2; 
    M2L1L2 = M(2)*L(1)*L(2); 
    I22 = I2M2L2; 

%   Flag variables ---------------------------    
    flag_inv = 0;                               % No inverse dynamics
    f = 1;                                      % Figure number

%   Optimization variables -------------------    
    T_init = .5;                                % Initial guess for period T
    tau_thresh = 20;                            % Maximum Torque of motors 
    res = .99;                                  % How accurately to optimize

%   Accuracy of mass estimation ---------------   
    accuracy = [1 0                             % Accuracy of mass estimation
                0 1];
    fprintf(' Done.\n');

%       
%   end ---------------------------------------