function q=inverseKinematics(x)
%   q=inverseKinematics(x)
%   INVERSE KINEMATICS. 
%   q:  relative joint angles;
%	x:  endpoint position vectors where col1 is x and col 2 is y; 

    global L;
%     global OFFY;
    % Segment Lengths
    q=zeros(size(x));                                                   % initialize

    xx=x(:,1);
    yy=x(:,2);%+OFFY;
    c2=(xx.^2 + yy.^2 - L(1)^2 - L(2)^2) / (2 * L(1)* L(2));
    s2=sqrt(1-c2.^2);

    q(:,2)=acos(c2);                   
    q(:,1)=atan2(yy,xx) - atan2(L(2)*s2, L(1) + L(2)*c2);
  