% Marianna Semprini
% IIT, December 2010

function varargout = DynamicShaping(varargin)
% DYNAMICSHAPING M-file for DynamicShaping.fig
%      DYNAMICSHAPING, by itself, creates a new DYNAMICSHAPING or raises the existing
%      singleton*.
%
%      H = DYNAMICSHAPING returns the handle to a new DYNAMICSHAPING or the handle to
%      the existing singleton*.
%
%      DYNAMICSHAPING('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DYNAMICSHAPING.M with the given input arguments.
%
%      DYNAMICSHAPING('Property','Value',...) creates a new DYNAMICSHAPING or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before DynamicShaping_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to DynamicShaping_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help DynamicShaping

% Last Modified by GUIDE v2.5 22-Dec-2010 09:40:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @DynamicShaping_OpeningFcn, ...
                   'gui_OutputFcn',  @DynamicShaping_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before DynamicShaping is made visible.
function DynamicShaping_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to DynamicShaping (see VARARGIN)

% Choose default command line output for DynamicShaping
handles.output = hObject;

display(' ')
display('DYNAMIC SHAPING SOFTWARE')
display('------------------------')
display(' ')
ready = 0;
while(~ready)
    display('Choose running mode: 1-exp 2-debug')
    handles.MODE = input('MODE = ') ;  
    display(' ')
    if handles.MODE==1 % set default parameters for experiment mode
        ready = 1;
    elseif handles.MODE==2 % set default parameters for debug mode
        ready = 1;
    else
        display('Please select a proper value! ')
        display(' ')
        ready = 0;
    end
end

% initialize setup parameters
handles.n_REC_electrodes = 16;
handles.n_STIM_electrodes = 4;
handles.n_STIM_patterns = handles.n_STIM_electrodes;
handles.STIM_patterns = eye(handles.n_STIM_patterns);
handles.radio = [];
handles.units = [[1:handles.n_REC_electrodes]; ones(1, handles.n_REC_electrodes)];
handles.T = 200;    % ms
handles.dT = 5;     % ms
handles.rawT = 600; % ms
handles.rawdT = 1;  % ms
handles.activity = zeros(handles.n_REC_electrodes, handles.rawT/handles.rawdT);

% initialize dynamic field parameters
handles.mass = 10*eye(2);
handles.damping = 15*eye(2);
handles.stiffness = 4*eye(2);
handles.zeroRadius = 2;
handles.zeroCenter = [0 0];
handles.fieldLimits = [-10 10 -10 10];  % [Xmin Xmax Ymin Ymax]
handles.runTime = 1;
handles.totalTime = 100;
[handles.gainF, handles.maxF] = setForceGraphics(handles.fieldLimits, -handles.stiffness);
[handles.Xrange, handles.Yrange]= rangeF(handles.stiffness, handles.fieldLimits(1:2), handles.fieldLimits(3:4));  % calculate force range

% initialize BMI parameters
handles.calibration_cycles = 50;
handles.windows = [100 200 400 600];    % ms
handles.bins = [5 10];                  % ms
handles.pause = 1; % time between stimulations
handles.test_trials = 10;
handles.calibrationDone = 0;

handles.state = zeros(1,4); % state vector: [x y Vx Vy]
handles.force = zeros(1,2); % force vector: [Fx Fy]
handles.current_stimulation = 1;
handles.tri = 0;
handles.stimulation_color = ['k' 'r' 'g' 'c' 'y' 'm'];
handles.scaleMatrix = zeros(2, handles.n_STIM_patterns);
handles.invPHI = zeros(handles.n_STIM_patterns);
handles.meanD = 0;
handles.meanData = zeros(numel(handles.rawT)/numel(handles.rawdT), handles.n_REC_electrodes, handles.n_STIM_patterns);

% create data containers
handles.dataTrain = zeros(handles.rawT/handles.rawdT, handles.calibration_cycles, handles.n_REC_electrodes, handles.n_STIM_patterns);
handles.dataTest = zeros(handles.rawT/handles.rawdT, handles.calibration_cycles, handles.n_REC_electrodes, handles.n_STIM_patterns);
handles.dataTrainDB = cell(numel(handles.windows), numel(handles.bins));
handles.dataTestDB = cell(numel(handles.windows), numel(handles.bins));
handles.R = zeros(2, handles.calibration_cycles, handles.n_STIM_patterns);
for ii = 1:numel(handles.windows)
    for jj = 1:numel(handles.bins)
        handles.dataTrainDB{ii, jj} = zeros(handles.windows(ii)/handles.bins(jj), handles.calibration_cycles, handles.n_REC_electrodes, handles.n_STIM_patterns);
        handles.dataTestDB{ii, jj} = zeros(handles.windows(ii)/handles.bins(jj), handles.calibration_cycles, handles.n_REC_electrodes, handles.n_STIM_patterns);
        handles.scaleMatrixDB{ii, jj} = zeros(2, handles.n_STIM_patterns);
        handles.invPHIDB{ii, jj} = zeros(handles.n_STIM_patterns);
        handles.meanDDB{ii, jj} = 0;
        handles.meanDataDB{ii, jj} = zeros(handles.windows(ii)/handles.bins(jj), handles.n_REC_electrodes, handles.n_STIM_patterns); 
        handles.recForceDB{ii,jj} = zeros(2, handles.n_STIM_patterns);
        handles.recPointDB{ii, jj} = zeros(2, handles.n_STIM_patterns);
        handles.RDB{ii, jj} = zeros(2, handles.calibration_cycles, handles.n_STIM_patterns);
    end
end

% create saving data structure
handles.runData.state = zeros(4, round(handles.totalTime/handles.runTime));
handles.runData.force = zeros(2, round(handles.totalTime/handles.runTime));
handles.runData.stimulation = zeros(1, round(handles.totalTime/handles.runTime));
handles.runData.response = zeros(handles.T/handles.dT, round(handles.totalTime/handles.runTime));    %%%%% aggiungere num electr
handles.save = 1;

if handles.MODE == 1    % experiment mode
    % Plexon system configuration
    handles.plexon = PL_InitClient(0); 
    
    % Stimulator configuration
    handles.dio = digitalio('nidaq','Dev2');  
    handles.lines = addline(handles.dio,0:handles.n_STIM_electrodes-1, 'out');
    %handles.lines = addline(handles.dio,8:11,'out');
end

% initialize information parameters
handles.optsI.nt = handles.calibration_cycles;
handles.optsI.method = 'dr';
handles.optsI.bias = 'pt';
handles.optsI.btsp = 10;
handles.information = zeros(numel(handles.windows), numel(handles.bins), handles.optsI.btsp+1);
        
% plot neural responses
axes(handles.response_axes);  
imagesc(handles.activity); colorbar;                      
axis([1 round(handles.rawT/handles.rawdT) 1 handles.n_REC_electrodes]);
set(gca,'xtick',[0:50:round(handles.rawT/handles.rawdT)], 'xticklabel', [0:50*handles.rawdT:handles.rawT]);
xlabel(['T [steps of ' num2str(handles.rawdT) ' ms]']);
ylabel('neural responses');
                
% plot stimulation patterns
axes(handles.stimuli_axes);
handles.stimuli_image = imagesc(handles.STIM_patterns,[0 10]);
xlabel('stimulating electrodes');
ylabel('stimulation patterns');

axes(handles.field_axes);
hold on;
axis(handles.fieldLimits);
plotfield(handles.fieldLimits, @stiff_field, handles, 2);
plotcircle(handles.zeroCenter(1), handles.zeroCenter(2), handles.zeroRadius);
set(gca, 'xtick', [], 'ytick', [], 'box', 'on');

axes(handles.space_axes);
hold on;
axis(handles.fieldLimits);
plotcircle(handles.zeroCenter(1), handles.zeroCenter(2), handles.zeroRadius);
set(gca, 'xtick', [], 'ytick', [],  'box', 'on');

% Update handles structure
guidata(hObject, handles);


% UIWAIT makes DynamicShaping wait for user response (see UIRESUME)
% uiwait(handles.DS_figure);


% --- Outputs from this function are returned to the command line.
function varargout = DynamicShaping_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in field_parameters_pushbutton.
function field_parameters_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to field_parameters_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

prompt = {'Mass Matrix:','Damping Matrix:', 'Stiffness Matrix', 'Zero Radius', 'Zero Center', 'Field Limits', 'Step Time', 'Total Time'};
dlg_title = 'Dynamical Parameters';
num_lines = [2 2 2 1 1 1 1 1]';
def = {num2str(handles.mass),num2str(handles.damping), num2str(handles.stiffness), num2str(handles.zeroRadius), num2str(handles.zeroCenter), num2str(handles.fieldLimits), num2str(handles.runTime), num2str(handles.totalTime)};
answer = inputdlg(prompt,dlg_title,num_lines,def);
if ~isempty(answer)
    handles.mass = str2num(answer{1,1});
    handles.damping = str2num(answer{2,1});
    handles.stiffness = str2num(answer{3,1});
    handles.zeroRadius = str2num(answer{4,1});
    handles.zeroCenter = str2num(answer{5,1});
    handles.fieldLimits = str2num(answer{6,1});
    handles.runTime = str2num(answer{7,1});
    handles.totalTime = str2num(answer{8,1});
    handles.nTicks = handles.totalTime/handles.runTime;
end

[handles.gainF, handles.maxF] = SetForceGraphics(handles.fieldLimits, -handles.stiffness);
[handles.Xrange, handles.Yrange]= rangeF(handles.stiffness, handles.fieldLimits(1:2), handles.fieldLimits(3:4));  % calculate force range

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in calibration_pushbutton.
function calibration_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to calibration_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.BMI_parameters_pushbutton,'enable','off');
set(handles.field_parameters_pushbutton,'enable','off');
set(handles.initial_condition_pushbutton, 'enable', 'off');
set(handles.step_pushbutton, 'enable', 'off');
set(handles.run_pushbutton, 'enable', 'off');
set(handles.test_pushbutton, 'enable', 'off');
set(handles.nf_pushbutton, 'enable', 'off');

prompt = {'Calibration cycles', 'Recording windows', 'Recording bins'};
dlg_title = 'Calibration Parameters';
num_lines = [1 1 1]';
def = {num2str(handles.calibration_cycles), num2str(handles.windows), num2str(handles.bins)};
answer = inputdlg(prompt,dlg_title,num_lines,def);
if ~isempty(answer)
    handles.calibrationDone = 0;
    handles.calibration_cycles = str2num(answer{1,1});
    handles.windows = str2num(answer{2,1});
    handles.bins = str2num(answer{3,1});

    % initialize data matrices and containers
    handles.dataTrain = zeros(handles.rawT/handles.rawdT, handles.calibration_cycles, handles.n_REC_electrodes, handles.n_STIM_patterns);
    handles.dataTest = zeros(handles.rawT/handles.rawdT, handles.calibration_cycles, handles.n_REC_electrodes, handles.n_STIM_patterns);
    
    handles.dataTrainDB = cell(numel(handles.windows), numel(handles.bins));
    handles.dataTestDB = cell(numel(handles.windows), numel(handles.bins));
    handles.R = zeros(2, handles.calibration_cycles, handles.n_STIM_patterns);
    handles.information = zeros(numel(handles.windows), numel(handles.bins), 11); % 1 information + 10 bootstrap values
    for ii = 1:numel(handles.windows)
        for jj = 1:numel(handles.bins)
            handles.dataTrainDB{ii, jj} = zeros(handles.windows(ii)/handles.bins(jj), handles.calibration_cycles, handles.n_REC_electrodes, handles.n_STIM_patterns);
            handles.dataTestDB{ii, jj} = zeros(handles.windows(ii)/handles.bins(jj), handles.calibration_cycles, handles.n_REC_electrodes, handles.n_STIM_patterns);
            handles.scaleMatrixDB{ii, jj} = zeros(2, handles.n_STIM_patterns);
            handles.invPHIDB{ii, jj} = zeros(handles.n_STIM_patterns);
            handles.meanDDB{ii, jj} = 0;
            handles.meanDataDB{ii, jj} = zeros(handles.windows(ii)/handles.bins(jj), handles.n_REC_electrodes, handles.n_STIM_patterns);
            handles.recForceDB{ii,jj} = zeros(2, handles.n_STIM_patterns);
            handles.recPointDB{ii, jj} = zeros(2, handles.n_STIM_patterns);
            handles.RDB{ii, jj} = zeros(2, handles.calibration_cycles, handles.n_STIM_patterns);
        end
    end
    
    % collect train data
    for ii = 1:handles.calibration_cycles
        for jj = 1:handles.n_STIM_patterns
            if handles.MODE == 1    % experiment mode
                stimulate(jj, handles.dio);
                activity = record(handles.plexon, handles.rawT, handles.rawdT, handles.units); % activity is a (units X time) matrix
                axes(handles.response_axes);
                imagesc(activity); colorbar;
                axis([1 round(handles.rawT/handles.rawdT) 1 handles.n_REC_electrodes]);
                set(gca,'xtick',[0:50:round(handles.rawT/handles.rawdT)], 'xticklabel', [0:50*handles.rawdT:handles.rawT]); 
                xlabel(['T [steps of ' num2str(handles.rawdT) ' ms]']);
                ylabel('neural responses');
                pause(handles.pause);
            else                    % debug mode
                activity = round(rand(handles.n_REC_electrodes, handles.rawT/handles.rawdT));
            end
            handles.dataTrain(:,ii,:,jj) = activity';            
        end
    end
    handles.dataTrain(find(handles.dataTrain)) = 1; % remove fake spikes
    
    for kk = 1:numel(handles.windows)
        for hh = 1:numel(handles.bins)
            T = handles.windows(kk);
            dT = handles.bins(hh);
            data = createDataSet(handles.dataTrain, [0 T dT]); % resample data according to T and dT
            handles.dataTrainDB{kk,hh} = data;
        end
    end

    % calculate transformation matrices and calibration forces
    for ii = 1:numel(handles.windows)
        for jj = 1:numel(handles.bins)
            data = handles.dataTrainDB{ii,jj};
            T = handles.windows(ii);
            dT = handles.bins(jj);
            [handles.scaleMatrixDB{ii,jj}, handles.invPHIDB{ii,jj}, handles.meanDDB{ii,jj}] = calibration(data, [handles.Xrange, handles.Yrange]);   % run calibration
            
            meanData = zeros(T/dT, handles.n_REC_electrodes, handles.n_STIM_patterns);
            meanData(1:T/dT,1:handles.n_REC_electrodes,1:handles.n_STIM_patterns) = squeeze(nanmean(data,2)); % phi
            handles.meanDataDB{ii,jj} = meanData;
            
            recForce = handles.recForceDB{ii,jj};
            for kk = 1:handles.n_STIM_patterns
                activityTmp = repmat(squeeze(meanData(:,:,kk)), [1, 1, handles.n_STIM_patterns]);
                F = squeeze(sum(sum(meanData.*activityTmp,1),2));
                recForce(:,kk) = handles.scaleMatrixDB{ii,jj}*(handles.invPHIDB{ii,jj}*F - handles.meanDDB{ii,jj}');
            end
            handles.recForceDB{ii,jj} = recForce;
            handles.recPointDB{ii, jj} = -inv(handles.stiffness)*recForce;    % derive recPoint
        end
    end

    % collect test data
    for ii = 1:handles.calibration_cycles
        for jj = 1:handles.n_STIM_patterns
            if handles.MODE == 1    % experiment mode
                stimulate(jj, handles.dio);
                activity = record(handles.plexon, handles.rawT, handles.rawdT, handles.units); % activity is a (units X time) matrix
                axes(handles.response_axes);
                imagesc(activity); colorbar;                
                axis([1 round(handles.rawT/handles.rawdT) 1 handles.n_REC_electrodes]);
                set(gca,'xtick',[0:50:round(handles.rawT/handles.rawdT)], 'xticklabel', [0:50*handles.rawdT:handles.rawT]);
                xlabel(['T [steps of ' num2str(handles.rawdT) ' ms]']);
                ylabel('neural responses');
                pause(handles.pause);
            else                    % debug mode
                activity = round(rand(handles.n_REC_electrodes, handles.rawT/handles.rawdT));
            end
            handles.dataTest(:,ii,:,jj) = activity';            
        end
    end
    handles.dataTest(find(handles.dataTest)) = 1; % remove fake spikes
    
    for kk = 1:numel(handles.windows)
        for hh = 1:numel(handles.bins)
            T = handles.windows(kk);
            dT = handles.bins(hh);
            data = createDataSet(handles.dataTest, [0 T dT]); % resample data
            handles.dataTestDB{kk,hh} = data;
        end
    end
    
    % calculate forces and information values
    for ii = 1:numel(handles.windows)
        for jj = 1:numel(handles.bins)
            data = handles.dataTestDB{ii,jj};
            handles.RDB{ii, jj}(:) = 0;
            for kk = 1:handles.n_STIM_patterns
                meanData = zeros(size(data));
                for hh = 1:handles.calibration_cycles
                    meanData(:,hh,:,:) = handles.meanDataDB{ii,jj};
                end
                tmpData = zeros(size(data,1), size(data,2), size(data,3)); % needed in case of 1 calibration cycle
                tmpData(:,:,:) = squeeze(data(:,:,:,kk));
                activity = repmat(tmpData, [1, 1, 1,handles.n_STIM_patterns]);
                F = squeeze(sum(sum(meanData.*activity,1),3))';
                meanD = repmat(handles.meanDDB{ii,jj}', 1, handles.calibration_cycles);
                handles.RDB{ii, jj}(:,:,kk) = handles.scaleMatrixDB{ii,jj}*(handles.invPHIDB{ii,jj}*F - meanD);
            end
            R = handles.RDB{ii, jj};
            handles.optsI.nt = handles.calibration_cycles;
            R = binr(R, handles.optsI.nt, 5, 'eqpop');
            handles.information(ii, jj, :) = information(R, handles.optsI, 'Ish');
        end
    end
    figure(100)
    for ii = 1:numel(handles.bins)
        subplot(numel(handles.bins),1,ii)
        infoTmp = squeeze(handles.information(:,ii,:))';
        imagesc([infoTmp(1,:); nanmean(infoTmp(2:end,:))]); colorbar;
        set(gca,'xtick',[1:handles.n_STIM_patterns], 'xticklabel', [1:handles.n_STIM_patterns],'ytick',[1 2], 'yticklabel',{'I', 'btsp'});
        title(['dT = ' num2str(handles.bins(ii)) ' [ms]'])
        ylabel('Information [bit]');   
    end
    xlabel('window size [ms]')

    % select current window and bin
    w = find(handles.windows == handles.T);
    b = find(handles.bins == handles.dT);
    handles.scaleMatrix = handles.scaleMatrixDB{w, b};
    handles.invPHI = handles.invPHIDB{w, b};
    handles.meanD = handles.meanDDB{w, b};
    handles.meanData = handles.meanDataDB{w, b};
    handles.recForce = handles.recForceDB{w,b};
    handles.recPoint = handles.recPointDB{w,b};

    tmpPath = cd;
    [filename, pathname] = uiputfile({'*.mat';'*.*'}, 'Save data');
    if pathname
        cd(pathname);
        save(filename, 'handles');
        cd(tmpPath);
    end

    set(handles.initial_condition_pushbutton, 'enable', 'on');
    set(handles.BMI_parameters_pushbutton,'enable','on');
    set(handles.field_parameters_pushbutton,'enable','on');
    set(handles.test_pushbutton, 'enable', 'on');
    set(handles.nf_pushbutton, 'enable', 'on');
    handles.calibrationDone = 1;
end

% Update handles structure
guidata(hObject, handles);



% --- Executes on button press in clear_field_pushbutton.
function clear_field_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to clear_field_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axes(handles.field_axes);
cla;
plotcircle(handles.zeroCenter(1), handles.zeroCenter(2), handles.zeroRadius);

% Update handles structure
guidata(hObject, handles);



% --- Executes on button press in clear_space_pushbutton.
function clear_space_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to clear_space_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axes(handles.space_axes);
cla;
plotcircle(handles.zeroCenter(1), handles.zeroCenter(2), handles.zeroRadius);

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in nf_pushbutton.
function nf_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to nf_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axes(handles.field_axes);
hold on;
try
    handles.tri = delaunay(handles.recPoint(1,:),handles.recPoint(2,:));
    triplot(handles.tri,handles.recPoint(1,:),handles.recPoint(2,:),'k');
    for ii = 1:handles.n_STIM_patterns
        plotSparseFieldData(handles.recPoint(:,ii), handles.recForce(:,ii), handles.gainF, handles.maxF, handles.stimulation_color(ii));
    end
catch
    % do nothing
end

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in df_pushbutton.
function df_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to df_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axes(handles.field_axes);
hold on;
axis(handles.fieldLimits);
plotfield(handles.fieldLimits, @stiff_field, handles, 2, 'k');
plotcircle(handles.zeroCenter(1), handles.zeroCenter(2), handles.zeroRadius);

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in initial_condition_pushbutton.
function initial_condition_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to initial_condition_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axes(handles.space_axes); hold on;
[xi, yi] = ginput(1);       % pick one point
handles.state = [xi yi 0 0];% set it as the initial state, start at rest
handles.tri = delaunay(handles.recPoint(1,:),handles.recPoint(2,:));
handles.current_stimulation = dsearch(handles.recPoint(1,:),handles.recPoint(2,:),handles.tri,handles.state(1),handles.state(2));
handles = runBMI(handles);
axes(handles.space_axes);
plotSparseFieldData([xi,yi]', handles.force', handles.gainF, handles.maxF);

set(handles.step_pushbutton, 'enable', 'on');
set(handles.run_pushbutton, 'enable', 'on');
set(handles.test_pushbutton, 'enable', 'on');
set(handles.nf_pushbutton, 'enable', 'on');

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in step_pushbutton.
function step_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to step_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = runBMI(handles);
axes(handles.space_axes);
plotSparseFieldData(handles.state', handles.force', handles.gainF, handles.maxF);
% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in run_pushbutton.
function handles = run_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to run_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.runData.state = zeros(4, round(handles.totalTime/handles.runTime));
handles.runData.force = zeros(2, round(handles.totalTime/handles.runTime));
handles.runData.stimulation = zeros(1, round(handles.totalTime/handles.runTime));
handles.runData.response = zeros(handles.n_REC_electrodes, handles.T/handles.dT, round(handles.totalTime/handles.runTime));

for ii = 1:round(handles.totalTime/handles.runTime)
    inside = indeadzone(handles.state, handles.zeroRadius, handles.zeroCenter);
    if inside
        % do nothing
    else
        handles = runBMI(handles);
        handles.runData.state(:,ii) = handles.state;
        handles.runData.force(:,ii) = handles.force;
        handles.runData.stimulation(:,ii) = handles.current_stimulation;
        handles.runData.response(:,:,ii) = handles.activity;
        
        axes(handles.space_axes);
        plotSparseFieldData(handles.state', handles.force', handles.gainF, handles.maxF);
%         pause(handles.pause);
        pause(2);
    end
end
% plot end point
axes(handles.field_axes);
plot(handles.state(1), handles.state(2),'*b');
if handles.save
    tmpPath = cd;
    [filename, pathname] = uiputfile({'run.mat'}, 'Save run data');
    if pathname
        cd(pathname);
        runData = handles.runData;
        save(filename, 'runData');
        cd(tmpPath);
    end
end

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in test_pushbutton.
function test_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to test_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

prompt = {'Number of trials'};
dlg_title = 'Test settings';
num_lines = [1]';
def = {num2str(handles.test_trials)};
answer = inputdlg(prompt,dlg_title,num_lines,def);
if ~isempty(answer)
    handles.test_trials = str2num(answer{1,1});
    handles.save = 0;
    runDataTest = cell(1, handles.test_trials);
    for ii = 1:handles.test_trials      
        % pick one random point
        xlimit = sum(abs(handles.fieldLimits(1:2)));
        ylimit = sum(abs(handles.fieldLimits(3:4)));
        xi = rand*xlimit - xlimit/2;   %Pick one point
        yi = rand*ylimit - ylimit/2;
        handles.state = [xi yi 0 0];% set it as the initial state, start at rest
        handles = runBMI(handles);
        axes(handles.space_axes);
        plotSparseFieldData([xi,yi]', handles.force', handles.gainF, handles.maxF);
        handles = run_pushbutton_Callback(handles.run_pushbutton, eventdata, handles);
        runDataTest{ii} = handles.runData;
    end
    tmpPath = cd;
    [filename, pathname] = uiputfile({'run.mat'}, 'Save run data');
    if pathname
        cd(pathname);
        for ii = 1:handles.test_trials
            runData = runDataTest{ii};
            new_filename = [filename(1:end-4) num2str(ii) filename(end-3:end)];
            save(new_filename, 'runData');
        end
        cd(tmpPath);
    end
    handles.save = 1;
end

% Update handles structure
guidata(hObject, handles);

function n_REC_electrodes_edit_Callback(hObject, eventdata, handles)
% hObject    handle to n_REC_electrodes_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n_REC_electrodes_edit as text
%        str2double(get(hObject,'String')) returns contents of n_REC_electrodes_edit as a double


% --- Executes during object creation, after setting all properties.
function n_REC_electrodes_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to n_REC_electrodes_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function n_STIM_electrodes_edit_Callback(hObject, eventdata, handles)
% hObject    handle to n_STIM_electrodes_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n_STIM_electrodes_edit as text
%        str2double(get(hObject,'String')) returns contents of n_STIM_electrodes_edit as a double

value = str2double(get(hObject,'String'));
if value ~= 4
    set(hObject,'String','4');
end


% --- Executes during object creation, after setting all properties.
function n_STIM_electrodes_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to n_STIM_electrodes_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function n_STIM_patterns_edit_Callback(hObject, eventdata, handles)
% hObject    handle to n_STIM_patterns_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n_STIM_patterns_edit as text
%        str2double(get(hObject,'String')) returns contents of n_STIM_patterns_edit as a double

value = str2double(get(hObject,'String'));
if value ~= 4
    set(hObject,'String','4');
end


% --- Executes during object creation, after setting all properties.
function n_STIM_patterns_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to n_STIM_patterns_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in BMI_parameters_pushbutton.
function BMI_parameters_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to BMI_parameters_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.stimuli_axes,'visible','off');
set(handles.stimuli_image, 'visible', 'off');
set(handles.BMI_parameters_uipanel, 'visible', 'on');
set(handles.n_REC_electrodes_edit, 'string', num2str(handles.n_REC_electrodes));
set(handles.n_STIM_electrodes_edit, 'string', num2str(handles.n_STIM_electrodes));
set(handles.n_STIM_patterns_edit, 'string', num2str(handles.n_STIM_patterns));
set(handles.BMI_parameters_pushbutton, 'enable', 'off');
set(handles.field_parameters_pushbutton, 'enable', 'off');
set(handles.calibration_pushbutton, 'enable', 'off');
set(handles.initial_condition_pushbutton, 'enable', 'off');
set(handles.step_pushbutton, 'enable', 'off');
set(handles.run_pushbutton, 'enable', 'off');
set(handles.test_pushbutton, 'enable', 'off');
set(handles.nf_pushbutton, 'enable', 'off');

handles.unitsTmp = handles.units;
handles.n_STIM_patternsTmp = handles.n_STIM_patterns;

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in set_REC_pushbutton.
function set_REC_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to set_REC_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.BMI_parameters_uipanel,'visible','off');
set(handles.REC_parameters_uipanel,'visible','on');
set(handles.ch_edit, 'string', num2str(handles.units(1,:)));
set(handles.u_edit, 'string', num2str(handles.units(2,:)));
set(handles.T_edit, 'string', num2str(handles.T));
set(handles.dT_edit, 'string', num2str(handles.dT));

guidata(hObject, handles);


% --- Executes on button press in set_STIM_pushbutton.
function set_STIM_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to set_STIM_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.BMI_parameters_uipanel,'visible','off');
set(handles.STIM_parameters_uipanel,'visible','on');
for ii = 1:length(handles.radio)
    set(handles.radio, 'visible','off')
end

handles.n_STIM_electrodes = str2double(get(handles.n_STIM_electrodes_edit, 'string'));
handles.n_STIM_patterns = str2double(get(handles.n_STIM_patterns_edit,'string'));

offset = 50;
dimension = 15;

panel_size = get(handles.STIM_parameters_uipanel,'position');
panel_w = panel_size(3)- 2*offset - dimension;
panel_h = panel_size(4)- 2*offset - dimension;
handles.radio = zeros(1,handles.n_STIM_electrodes*handles.n_STIM_patterns);
rows = handles.n_STIM_electrodes;
cols = handles.n_STIM_patterns;
index = handles.STIM_patterns(:);
[nR, nC] = find(~isnan(handles.STIM_patterns));
for ii = numel(handles.STIM_patterns):-1:1
    x = 1.5*offset + (panel_w/cols)*(nC(ii)-1);
    y = 2.5*offset + panel_h - (panel_h/rows)*(nR(ii)-1);
    handles.radio(ii) = uicontrol('parent',handles.STIM_parameters_uipanel,'style','checkbox','value',index(ii),'position',[x y dimension' dimension]);
end
guidata(hObject, handles);

% --- Executes on button press in OK_BMI_pushbutton.
function OK_BMI_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to OK_BMI_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.BMI_parameters_uipanel,'visible','off');
handles.n_REC_electrodes = str2num(get(handles.n_REC_electrodes_edit, 'string'));
handles.n_STIM_electrodes = str2num(get(handles.n_STIM_electrodes_edit, 'string'));
handles.n_STIM_patterns = str2num(get(handles.n_STIM_patterns_edit, 'string'));
set(handles.BMI_parameters_pushbutton, 'enable', 'on');
set(handles.field_parameters_pushbutton, 'enable', 'on');
set(handles.calibration_pushbutton, 'enable', 'on');
set(handles.stimuli_axes, 'visible', 'on');
set(handles.stimuli_image, 'visible', 'on');
axes(handles.response_axes); cla;
axis([1 round(handles.T/handles.dT) 1 handles.n_REC_electrodes]);
set(gca,'xtick',[0:10:round(handles.T/handles.dT)], 'xticklabel', [0:10*handles.dT:handles.T]);
xlabel(['T [steps of ' num2str(handles.dT) ' ms]']);
ylabel('neural responses');

if (size(handles.unitsTmp,2) == size(handles.units,2)) & (handles.n_STIM_patternsTmp == handles.n_STIM_patterns)  % number of units and stimulus pattern have not changed
    if ~isempty(handles.unitsTmp == handles.units) % units are the same
        if handles.calibrationDone
            set(handles.initial_condition_pushbutton, 'enable', 'on');
            set(handles.test_pushbutton, 'enable', 'on');
            set(handles.nf_pushbutton, 'enable', 'on');
        end
    end
end

guidata(hObject, handles);

% --- Executes on button press in OK_STIM_pushbutton.
function OK_STIM_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to OK_STIM_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

while handles.STIM_patterns > numel(handles.stimulation_color)
    handles.stimulation_color = [handles.stimulation_color handles.stimulation_color];
end

index = cell2mat(get(handles.radio,'value'));
pattern = zeros(size(index));
for ii = 1:numel(index)
    pattern(ii) = index(end-ii+1);
end
handles.STIM_patterns = reshape(pattern, handles.n_STIM_patterns, handles.n_STIM_electrodes);
axes(handles.stimuli_axes);
handles.stimuli_image = imagesc(handles.STIM_patterns,[0 10]);
xlabel('stimulating electrodes');
ylabel('stimulation patterns');

set(handles.stimuli_image, 'visible', 'off');
set(handles.stimuli_axes, 'visible', 'off');
set(handles.STIM_parameters_uipanel,'visible','off');
set(handles.BMI_parameters_uipanel,'visible','on');
guidata(hObject, handles);


% --- Executes on button press in OK_REC_pushbutton.
function OK_REC_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to OK_REC_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.units = 0;
try
    handles.units = [str2num(get(handles.ch_edit, 'string')); str2num(get(handles.u_edit, 'string'))];
catch
    errordlg('Number of channel and unit must be the same!', 'Wrong input!', 'modal');
end

if handles.units == 0
    
else
    handles.T = str2num(get(handles.T_edit, 'string'));
    handles.dT = str2num(get(handles.dT_edit, 'string'));

    handles.n_REC_electrodes = size(handles.units,2);
    set(handles.n_REC_electrodes_edit, 'string', num2str(handles.n_REC_electrodes));

    % select current window and bin
    w = find(handles.windows == handles.T);
    b = find(handles.bins == handles.dT);
    if isempty(w) | isempty(b)
        errordlg('T and dT must match the range of available values!', 'Wrong input!', 'modal');
    else
        handles.scaleMatrix = handles.scaleMatrixDB{w, b};
        handles.invPHI = handles.invPHIDB{w, b};
        handles.meanD = handles.meanDDB{w, b};
        handles.meanData = handles.meanDataDB{w, b};
        handles.recForce = handles.recForceDB{w,b};
        handles.recPoint = handles.recPointDB{w,b};
        
        set(handles.REC_parameters_uipanel,'visible','off');
        set(handles.BMI_parameters_uipanel,'visible','on');

        guidata(hObject, handles);
    end
end



function ch_edit_Callback(hObject, eventdata, handles)
% hObject    handle to ch_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ch_edit as text
%        str2double(get(hObject,'String')) returns contents of ch_edit as a double


% --- Executes during object creation, after setting all properties.
function ch_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ch_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function T_edit_Callback(hObject, eventdata, handles)
% hObject    handle to T_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T_edit as text
%        str2double(get(hObject,'String')) returns contents of T_edit as a double


% --- Executes during object creation, after setting all properties.
function T_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function dT_edit_Callback(hObject, eventdata, handles)
% hObject    handle to dT_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dT_edit as text
%        str2double(get(hObject,'String')) returns contents of dT_edit as a double


% --- Executes during object creation, after setting all properties.
function dT_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dT_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function u_edit_Callback(hObject, eventdata, handles)
% hObject    handle to u_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of u_edit as text
%        str2double(get(hObject,'String')) returns contents of u_edit as a double


% --- Executes during object creation, after setting all properties.
function u_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to u_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when user attempts to close DS_figure.
function DS_figure_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to DS_figure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

answer = questdlg('Do you really want to exit?','exit Dynamic Shaping','No');

switch answer
    case 'Yes'
        % Hint: delete(hObject) closes the figure
        delete(hObject);
    case 'No'
        return
end


