function inside = indeadzone(State, Radius, Zero)
% function indeadzone determines if the system is in deadzone
%
% State: state vector containing X and Y position and velocity
% Radius: radius of dead zone
% Zero: coorinates of dead zone center
%
% inside: 1-yes 0-no


x = State(1);   % X position
y = State(2);   % Y position
x0 = Zero(1);
y0 = Zero(2);
r = Radius;
dx = x-x0; 
dy = y-y0;
dist = sqrt(dx*dx+dy*dy);

inside = 0;     % default output
if dist < r
    inside = 1;
end