function plotfield(fieldRange, fieldfun, handles, step, col)
%
%  Plot the desired field (fieldfun)on the current axes.  Xrange and Yrange are
%  the [min, max] renges for the x and y variables. handles contains the parameters 
%   for the field function. step is the number of steps along the
%  axes of the x/y grid

if nargin <5
    col = 'b';
end
x= fieldRange(1):step:fieldRange(2);
y = fieldRange(3):step:fieldRange(4);
[XX, YY] = meshgrid(x, y);
[FX FY]= fieldfun(XX,YY, handles);
plotfld(XX, YY, FX, FY, handles.gainF, handles.maxF, col);



