function compdist_loop(opts)

% -------------------------
% load .mat file
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
load(fullfile(dirName, fileName));  % load data and dataParams;
trialN=dataParams.trialN;

% remove data with too little trials
badstim=trialN<30;
if isfield(dataParams,'stimPatterns') && ~isempty(dataParams.stimPatterns), dataParams.stimPatterns(badstim,:)=[]; end;
trialN(badstim)=[];
data(:,:,:,badstim)=[];

opts.trialN=trialN;

% -------------------------
% load parameters for computing distances
% -------------------------
dist_opts = dist_opts_REPOSITORY(opts.dist);
TETA = dist_opts.teta;
TC = dist_opts.tc;
% -------------------------

dist.set=opts.set;
dist.trialN=trialN;
dist.teta=TETA;
dist.tc=TC;
dist.D = nan(numel(TETA),numel(TC), sum(trialN), sum(trialN),'single');

for ii = 1:numel(TETA) 
    opts.teta = TETA(ii);
    for jj = 1:numel(TC) 
        opts.tc = TC(jj); 
        tic;
        sprintf('%s : distances with teta=%d and tc=%d',opts.set,opts.teta,opts.tc)
        dist.D(ii,jj,:,:)=compDist(data,opts);
        toc;
    end
end;

% save results
[dirName, fileName] = file_opts_REPOSITORY(opts, 'dist');
save(fullfile(dirName, fileName), 'dist');