function Dtr=compDistTrial2Calib(calmat, activity)

%_____________________________________________
% load transformation matrix from calibration
%_____________________________________________
nStim=calmat.nStim;
nTrial=calmat.nTrial;
nUnit=calmat.nUnit;
nT=calmat.nT;

K2D=calmat.K2D(1:nT,1:nT);
e=calmat.e;
Acal=calmat.Acal(1:nT,:,:);

% mapping of the spike trains to real functions with the kernel K
A=single(zeros(nT, nUnit));
for su=1:nUnit,
    A(:,su)=sum(K2D(squeeze(activity(:,su))>0,:),1);
end;

% project each SU response onto its unit vector (mapping to vector field)
% and summation of the vector fields associated to each neuron
Atr=zeros(size(A));
for dd=1:nUnit
    for uu=1:nUnit,
        Atr(:,dd)=squeeze(Atr(:,dd))+e(dd,uu)*A(:,uu);
    end;
end;

% compute distance between each pair of vector field
p=2;
Dtr=zeros(nStim,nTrial);
for ss=1:nStim
    for tt=1:nTrial
        Dtr(ss,tt)=(sum(sum((Atr-squeeze(Acal(:,(ss-1)*nTrial+tt,:))).^p,2),1)).^(1/p);
    end;
end;