function out=gaussian(x,y,center,sigma)
% 2D gaussian centered at [center(1) center(2)] with std dev sigma
% estimated at the [x y] points
% WARNING: x and y can be any size BUT x and y must be the SAME size
% EXAMPLE: ax=-50:50; [X,Y]=meshgrid(ax,ax);g=gaussian(X,Y,stimpos,stimspread); imagesc(ax,ax,g);
xc=center(1);
yc=center(2);
out=exp(-(((x-xc*ones(size(x))).^2+(y-yc*ones(size(y))).^2)./(2*sigma^2)));
