function createSimulatedDataSetMixed_2DM1(opts)
% create a simulated data set from the firing rate of an existing one

gamma=opts.gamma;

% [nt maxtrial nunit nstim] = size(data);

% -------------------------
% load simulation parameters
% -------------------------
sim2DM1_opts = sim2DM1_opts_REPOSITORY(opts.sim2DM1);
avgspknb=sim2DM1_opts.avgspknb;
nlev=length(avgspknb);
[nstim0 nSUs]=size(avgspknb{1});
nstim=nstim0*nlev;

% make the PSTHs more or less noisy
% gamma=1 : no information, gamma=0 : max info 
% gamma<0 more info! but need to threshold to zero
avgallspknb=0; % get overall average nb of spikes
for mm=1:nlev, 
    avgallspknb=avgallspknb+(1/nlev)*mean(avgspknb{mm}(:));
end;
avgspknbmix=cell(1,nlev);
for mm=1:nlev,
    avgspknbmix{mm}=abs(avgspknb{mm}+gamma*(avgallspknb*ones(size(avgspknb{mm}))-avgspknb{mm}));
end;

% -------------------------
% Generate simulated data set
% -------------------------
maxtrial=50; % 30 for calib and 30 for sim
% nbin=20;
nbin=120;

data=nan([nbin maxtrial nSUs nstim]);
ntrial=maxtrial*ones(1,nstim);

for uu = 1:nSUs
    %     for ss=1:nstim
    
    ss=1;
    for mm=1:nlev,
        
        for ss0=1:nstim0
            
            for tt=1:maxtrial
                nspk=poissrnd(avgspknbmix{mm}(ss0,uu));
                trn=[ones(1,nspk) zeros(1,nbin-nspk)];
%                 trn=[zeros(1,nbin-nspk) ones(1,nspk)];
                trn=trn(randperm(nbin));
                data(:,tt,uu,ss)=trn;
            end;
            %             data(1,:,uu,ss)=poissrnd(avgspknbmix(ss,uu),1,maxtrial);
            ss=ss+1;
        end;
    end;
end;

% -------------------------
% save simulated data set
% -------------------------
opts.set=[opts.sim2DM1 '_gamma' num2str(round(100*(gamma)))];
dataParams.trialN=ntrial;
% dataParams.nbin=10;
dataParams.gamma=gamma;

[dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
save(fullfile(dirName, fileName), 'data', 'dataParams','-v7.3');

