function cal_opts = cal_opts_REPOSITORY(opt)
% function cal_opts set calibration parameters according to opt

% default
cal_opts.unitset = 'allunits';
cal_opts.datorder='normal';
cal_opts.nCalibrations = 50;
cal_opts.decthresh=0;
cal_opts.minNStim=3;
% cal_opts.NBestStim=10; % if defined, decthresh & minNStim are not taken into account


switch(opt)
    
    case 'cal1'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 50;
        
    case 'cal1_mindecod50'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 50;
        cal_opts.decthresh=50;
        cal_opts.minNStim=6;
        
    case 'cal1_mindecod50b'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 50;
        cal_opts.decthresh=50;
        cal_opts.minNStim=10;
        
    case 'cal1_min6stimsdecthres20'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 50;
        cal_opts.decthresh=16;
        cal_opts.minNStim=6;
        
    case 'cal1_best10Stims'
        
        cal_opts.NBestStim=10; % if defined, decthresh & minNStim are not taken into account
        

    case 'calrand1'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='shuffle';
        cal_opts.nCalibrations = 50;
        
    case 'cal30'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 30;
        
    case 'cal40'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 40;
        
    case 'cal50'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 50;
        
    case 'cal60'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 60;
        
    case 'cal70'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 70;
        
    case 'cal100'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='normal';
        cal_opts.nCalibrations = 100;
        
    case 'cal100rand'
        
        cal_opts.unitset = 'allunits';
        cal_opts.datorder='shuffle';
        cal_opts.nCalibrations = 50;
end



