function dir_opts = dir_opts_REPOSITORY
% function dir_opts_REPOSITORY creates directories for different kind of data
%
% Marianna Semprini & Fran�ois Szymanski
% IIT, May 2010

global rootdir

dirs.root_data = fullfile(rootdir,'DATA');     % root data for analysis
dirs.root_plot = fullfile(rootdir,'FIG');       % root data for images

%-----------------------------------------------------------
% any figures (stationarity, psth, etc)
dir_opts.plotvar = fullfile(dirs.root_plot, 'var');  

% calibration figures
dir_opts.plotcalib = fullfile(dirs.root_plot, 'calibration');   

% interpolated field figures
dir_opts.plotInterpfield = fullfile(dirs.root_plot, 'interpfield'); 

% convergence rate and MI figures
dir_opts.plotPerfMI = fullfile(dirs.root_plot, 'perfMI'); 

% figures for analysis with multineuron distances
dir_opts.plotdist = fullfile(dirs.root_plot, 'dist'); 

% figures for analysis with different dynamical systems and simulated
% neurons
dir_opts.plotsimmix = fullfile(dirs.root_plot, 'simmix'); 

% figures for NIPS: comparison algos
dir_opts.plotNIPS = fullfile(dirs.root_plot, 'NIPS'); 

%-----------------------------------------------------------
% contains raw plx file
dir_opts.dirPlxData = fullfile(dirs.root_data, 'sortedData');   

 % contains raw mat file
dir_opts.dirMatData = fullfile(dirs.root_data, 'spikeData');   

% contains result of information analysis between spike trains and stimuli
dir_opts.dirMIStimSU = fullfile(dirs.root_data, 'MIStimSU');

% contains results of calibration
dir_opts.dirCalibration = fullfile(dirs.root_data, 'calibration'); 

% contains results of simulation and generated trajectories
dir_opts.dirSimulation = fullfile(dirs.root_data, 'simulation');  

% contains result of information analysis between expected and generated force
dir_opts.dirInfoForces = fullfile(dirs.root_data, 'infoForces');        

% contains result of information analysis between expected and generated force
dir_opts.dirInfoForcesFromTraj = fullfile(dirs.root_data, 'infoForcesFromTraj'); 

% contains distances between multineuron spike trains
dir_opts.dirDist = fullfile(dirs.root_data, 'distances'); 
%-----------------------------------------------------------
      

