function rec_opts = rec_opts_REPOSITORY(opt)
% function rec_opts set recording parameters according to opt
%
% opt: specifies experiment type
%
% rec_opts: recording parameters
%
% Marianna Semprini & Fran�ois Szymanski
% IIT, May 2010


switch(opt)
    
    %=========
    case 'rec0bin' % parameters used for the first study
        %=========
        rec_opts.bin = [1 5 10 20 50 100 150 200];
        rec_opts.window = 600;
        rec_opts.offset = 0;
        
        %=========
    case 'rec0offwin' % parameters used for the first study
        %=========
        rec_opts.bin = 5;
        rec_opts.window = [25 50 100:100:600];
        rec_opts.offset = 0:50:300;
        
        %=========
    case 'rec0' % parameters used for the first study
        %=========
        rec_opts.bin = 5;
        rec_opts.window = 600;
        rec_opts.offset = 0;
        
        %=========
    case 'rec1'
        %=========
        rec_opts.bin = [1 2 4 8 16 32 64 128 256];
        rec_opts.window = 640;
        rec_opts.offset = 0;
        
        %=========
    case 'rec2'
        %=========
        rec_opts.bin = 4;
        rec_opts.window = 600;
        rec_opts.offset = 0;
        
        %=========
    case 'rec3win'
        %=========
        rec_opts.bin = 20;
        rec_opts.window = [25 50 100:100:600];
        rec_opts.offset = 0;
        
        %=========
    case 'rec4win'
        %=========
        rec_opts.bin = 5;
        rec_opts.window = [100 200 400 600];
        rec_opts.offset = 0;
        
        %=========
    case 'recsimmix'
        %=========
        rec_opts.bin = 10;
        rec_opts.window = 500;
        rec_opts.offset = 0;
        
        %=========
    case 'recsim2DM1'
        %=========
        rec_opts.bin = 10;
        rec_opts.window = 10;
        rec_opts.offset = 0;
        
        %=========
    case 'recsim2DM1_20ms'
        %=========
        rec_opts.bin = 20;
        rec_opts.window = 20;
        rec_opts.offset = 0;
        
        %=========
    case 'recsim2DM1_120ms'
        %=========
        rec_opts.bin = 120;
        rec_opts.window = 120;
        rec_opts.offset = 0;
        
end

