function sim2DM1_opts = sim2DM1_opts_REPOSITORY(opt)
% function sim2DM1_opts_REPOSITORY set simulation parameters
% by defining relative geometries of stimulation and recording

switch(opt)
    
    %=========
    case 'sim2DM1_a'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=3;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_a3'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=[2 5 8];  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=3;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_4el1int'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=2;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=2;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_4el1int_ElCombi'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=2;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=2;         % number of rows and columns of recording electrodes
        EleComb=[1 2; 1 3; 2 4; 3 4]; % pairs of stimuli to be combined, chosen as to be neighbours, see [elposX elposY]
        
    case 'sim2DM1_4el3int'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=[2 5 8];  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=2;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=2;         % number of rows and columns of recording electrodes
             
        
    case 'sim2DM1_4el3int_ElCombi'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=[2 5 8];  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=2;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=2;         % number of rows and columns of recording electrodes
        EleComb=[1 2; 1 3; 2 4; 3 4]; % pairs of stimuli to be combined, chosen as to be neighbours, see [elposX elposY]
        
        
    case 'sim2DM1_4el3int_ElCombi_BrokenStimEl1'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=[2 5 8];  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=2;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=2;         % number of rows and columns of recording electrodes
        EleComb=[1 2; 1 3; 2 4; 3 4]; % pairs of stimuli to be combined, chosen as to be neighbours, see [elposX elposY]
        BrokenStimEl=[1];
        
    case 'sim2DM1_4el3int_ElCombi_BrokenRecEl1'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=[2 5 8];  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=2;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=2;         % number of rows and columns of recording electrodes
        EleComb=[1 2; 1 3; 2 4; 3 4]; % pairs of stimuli to be combined, chosen as to be neighbours, see [elposX elposY]
        BrokenRecEl=[1];
        
        %=========
    case 'sim2DM1_b'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=1;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=0.5;           % spacing between recording electrodes
        nbel=6;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_c'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=1;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=6;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=6;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_d'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=6;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=6;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_d_std05'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=6;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=6;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_d_std10'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=6;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=6;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_d_std15'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=6;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=6;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_d_std20'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=2;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=6;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=6;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_e'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=5;    % number of rows and columns of stimulating electrodes
        dr=.6;           % spacing between recording electrodes
        nbel=7;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_f_std05'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=.6;           % spacing between recording electrodes
        nbel=4;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_f_std10'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1.0;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=.6;           % spacing between recording electrodes
        nbel=4;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_f_std15'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=.6;           % spacing between recording electrodes
        nbel=4;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_f_std20'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=2.0;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=.6;           % spacing between recording electrodes
        nbel=4;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_7bits'
        ds=2;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=10:10:80;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=4;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels*2;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_7bitsb'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=4;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_7bitsc' % best (as good as d and e)
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=10:10:80;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=4;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_7bitsd'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=10:10:80;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=4;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels*2;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_7bitse'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=10:10:80;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=4;    % number of rows and columns of stimulating electrodes
        dr=0.5;           % spacing between recording electrodes
        nbel=nbbarrels*2;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_7bits_square'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=10:10:80;  % average number of spikes evoked at the peak of the gaussian
        stimposX=[0 0 0 0 0 1 2 3 4 4 4 4 4 3 2 1];
        stimposY=[0 1 2 3 4 4 4 4 4 3 2 1 0 0 0 0];
        stimspacing=0:4;
        nbbarrels=5;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_5bits_square'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=10:10:40;  % average number of spikes evoked at the peak of the gaussian
        stimposX=[0 0 0 1 2 2 2 1];
        stimposY=[0 1 2 2 2 1 0 0];
        stimspacing=0:2;
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_5bits_square_BrokenRecEl1'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=10:10:40;  % average number of spikes evoked at the peak of the gaussian
        stimposX=[0 0 0 1 2 2 2 1];
        stimposY=[0 1 2 2 2 1 0 0];
        stimspacing=0:2;
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels;         % number of rows and columns of recording electrodes
        BrokenRecEl=[1];
        
     case 'sim2DM1_5bits_square_BrokenStimEl1'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=10:10:40;  % average number of spikes evoked at the peak of the gaussian
        stimposX=[0 0 0 1 2 2 2 1];
        stimposY=[0 1 2 2 2 1 0 0];
        stimspacing=0:2;
        nbbarrels=3;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels;         % number of rows and columns of recording electrodes    
        BrokenStimEl=[1];
        
    case 'sim2DM1_3bits_square'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=0.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=[5 10];  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=2;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_144el'
        ds=4;           % stimulus spacing (FIXED to 1)
        stimspread=1.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=8;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=12;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=nbbarrels*ds;         % number of rows and columns of recording electrodes
        
        
    case 'sim2DM1_144elb' % best
        ds=2;           % stimulus spacing (FIXED to 1)
        stimspread=2;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=8;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=12;    % number of rows and columns of stimulating electrodes
        dr=0.5;           % spacing between recording electrodes
        nbel=nbbarrels*ds/dr;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_144elc'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=.5;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=12;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=12;         % number of rows and columns of recording electrodes
        
    case 'sim2DM1_144eld'
        ds=1;           % stimulus spacing (FIXED to 1)
        stimspread=1;   % stimulus spread : standard deviation of the gaussian
        maxavgspknb=5;  % average number of spikes evoked at the peak of the gaussian
        nbbarrels=12;    % number of rows and columns of stimulating electrodes
        dr=1;           % spacing between recording electrodes
        nbel=12;         % number of rows and columns of recording electrodes
end

%%
        
if ~exist('stimposX','var')||~exist('stimposY','var')
    
    % stimulus grid positions
    stimspacing=ds*(0:(nbbarrels-1));
    [stimposX,stimposY]=meshgrid(stimspacing,stimspacing);
    
end;

    % electrode grid positions
    elspacing=dr*(0:(nbel-1));
    elspacing=elspacing+mean(stimspacing([1 end]))-mean(elspacing([1 end]));
    [elposX,elposY]=meshgrid(elspacing,elspacing);
    
% compute average number of spikes recorded in each electrode in response
% to each stimulus
avgspknb=cell(1,length(maxavgspknb));
for mm=1:length(maxavgspknb)
    avgspknb{mm}=nan(length(stimposX(:)),length(elposX(:)));
    for ss=1:length(stimposX(:))
        spknb=maxavgspknb(mm)*gaussian(elposX,elposY,[stimposX(ss) stimposY(ss)],stimspread);
        avgspknb{mm}(ss,:)=spknb(:);
    end;
end;

if exist('BrokenStimEl','var')||exist('BrokenRecEl','var')
    avgallspknb=0; % get overall average nb of spikes
    for mm=1:length(maxavgspknb),
        avgallspknb=avgallspknb+(1/length(maxavgspknb))*mean(avgspknb{mm}(:));
    end;
end;

if exist('BrokenStimEl','var') % is that plausible?
    for ee=1:length(BrokenStimEl)
        for mm=1:length(maxavgspknb)
            avgspknb{mm}(ee,:)=avgallspknb*ones(1,length(elposX(:)));
        end;
    end;
end;

% EleComb=[1 2; 1 3; 2 4; 3 4];
if exist('EleComb','var')
    NextraStims=size(EleComb,1);
    avgspknb2=cell(1,length(maxavgspknb));
    for mm=1:length(maxavgspknb)
        avgspknb2{mm}=nan(length(stimposX(:))+NextraStims,length(elposX(:)));
        avgspknb2{mm}(1:length(stimposX(:)),:)=avgspknb{mm};
        for ss=1:NextraStims
            avgspknb2{mm}(length(stimposX(:))+ss,:)=sum(avgspknb{mm}(EleComb(ss,:),:));
        end;
    end;
    avgspknb=avgspknb2;
end;

if exist('BrokenRecEl','var')
    for ee=1:length(BrokenRecEl)
        for mm=1:length(maxavgspknb)
            avgspknb{mm}(:,ee)=avgallspknb*ones(length(avgspknb{mm}(:,ee)),1);
        end;
    end;
end;

sim2DM1_opts.ds=ds;
sim2DM1_opts.stimspread=stimspread;
sim2DM1_opts.maxavgspknb=maxavgspknb;
sim2DM1_opts.nbbarrels=nbbarrels;
sim2DM1_opts.dr=dr;
sim2DM1_opts.nbel=nbel;
sim2DM1_opts.stimspacing=stimspacing;
sim2DM1_opts.stimposX=stimposX;
sim2DM1_opts.stimposY=stimposY;
sim2DM1_opts.elspacing=elspacing;
sim2DM1_opts.elposX=elposX;
sim2DM1_opts.elposY=elposY;
sim2DM1_opts.avgspknb=avgspknb;


% %
% for mm=length(maxavgspknb)
% 
% %     figure(mm); clf;
% 
%     figure(mm+10); clf;
% 
%     for ss=1:length(stimposX(:))
% 
%         % select one stimulus
%         stim=[stimposX(ss) stimposY(ss)];
% 
%         % spike probabilities with overlayed electrode positions
%         figure(mm); subplot(length(stimspacing),length(stimspacing),ss);
%         ax=min([elspacing(1) stimspacing(1)]):(dr/10):max([elspacing(end) stimspacing(end)]); [X,Y]=meshgrid(ax,ax);
%         g=maxavgspknb(mm)*gaussian(X,Y,stim,stimspread);
%         imagesc(ax,ax,g);
% %         colorbar; title(['stimulus' num2str(ss)]);
% set(gca,'ytick',[],'xtick',[])
%         hold on; 
%         set(gca,'ydir','normal')
%         plot(elposX(:),elposY(:),'ow'); % plot electrodes
%         caxis([0 max(maxavgspknb)]);
% 
%         % spike probabilities in each electrode
%         figure(mm+10); subplot(length(stimspacing),length(stimspacing),ss);
%         avgspknb=maxavgspknb(mm)*gaussian(elposX,elposY,stim,stimspread);
%         imagesc(elspacing,elspacing,avgspknb);
% %         colorbar; title(['stimulus' num2str(ss)]);
% set(gca,'ytick',[],'xtick',[])
%         set(gca,'ydir','normal')
%         caxis([0 max(maxavgspknb)]);
% %         pause
%     end;
% end;
% 
