function sim_opts = sim_opts_REPOSITORY(opt)
% function time_opts set simulation temporal parameters according to opt
%
% opt: specifies experiment type
%
% sim_opts: parameters for simulation
%
% Marianna Semprini & Fran�ois Szymanski
% IIT, May 2010


switch(opt)
    
    
    %=========
    case 'sim1'
        %=========
        sim_opts.nRun = 100;
        sim_opts.runTime = 1;
        sim_opts.totalTime = 100;
        
        %=========
    case 'sim2'
        %=========
        sim_opts.nRun = 100;
        sim_opts.runTime = 1;
        sim_opts.totalTime = 200;
        
                
        %=========
    case 'sim3'
        %=========
        % determine starting positions
        teta=0:pi/8:15*pi/8;
        r=0.8;
        nperang=10;
        xi=repmat(cos(teta),1,nperang);
        yi=repmat(sin(teta),1,nperang);
        
        sim_opts.nRun = length(xi);
        sim_opts.runTime = 1;
        sim_opts.totalTime = 200;
        
        sim_opts.X0=r*[xi;yi];
        sim_opts.teta=teta;
        sim_opts.nperang=nperang;
        
    case 'sim4' % grid
        %=========
        % determine starting positions
        r=0.8;        
        nperpos=1;
        ax=-r:0.2:r;
        xi=repmat(ax,length(ax),1);
        yi=xi';
        xi=xi(:);
        yi=yi(:);
        xi=repmat(xi,nperpos,1);
        yi=repmat(yi,nperpos,1);

        sim_opts.nRun = length(xi);
        sim_opts.runTime = 1;
        sim_opts.totalTime = 50;
        
        sim_opts.X0=[xi';yi'];
        sim_opts.ax=ax;
        sim_opts.nperpos=nperpos;
        
    case 'sim5' % square
        %=========
        % determine starting positions
        r=0.8;        
        nperpos=10;
        ax=-r:0.2:r;
        
        xi=ax;
        yi=r*ones(1,length(ax));
        xi=[xi r*ones(1,length(ax)-1)];
        yi=[yi fliplr(ax(1:end-1))];
        xi=[xi fliplr(ax(1:end-1))];
        yi=[yi -r*ones(1,length(ax)-1)];
        xi=[xi -r*ones(1,length(ax)-2)];
        yi=[yi ax(2:end-1)];
        xi=xi'; yi=yi';
        
        xi=repmat(xi,nperpos,1);
        yi=repmat(yi,nperpos,1);

        sim_opts.nRun = length(xi);
        sim_opts.runTime = 1;
        sim_opts.totalTime = 50;
        
        sim_opts.X0=[xi';yi'];
        sim_opts.ax=ax;
        sim_opts.nperpos=nperpos;
        
end



