% Marianna Semprini & Fran�ois Szymanski
% IIT, May 2010

setrootdir;
getsetList;

opts.rec = 'rec1';
opts.cal='cal1'; uu=1;
opts.algo = 'algo1';
opts.dynSys = 'dynSys1';
opts.sim = 'sim1';
opts.MIForce='FxFy1';

% -------------------------
% load sampling parameters
% -------------------------
rec_opts = rec_opts_REPOSITORY(opts.rec);
BIN = rec_opts.bin;
WINDOW = rec_opts.window;
OFFSET = rec_opts.offset;
% -------------------------

step = zeros(length(setList),numel(BIN)*numel(WINDOW)*numel(OFFSET),2); 
invStep = zeros(length(setList),numel(BIN)*numel(WINDOW)*numel(OFFSET),1); 
info = zeros(length(setList),numel(BIN)*numel(WINDOW)*numel(OFFSET),1); 
r = zeros(length(setList),1);

for ff = 1:length(setList)
    opts.set = setList{ff};
    disp(opts.set);
    % -------------------------
    % load info forces file
    % -------------------------
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'infoForce');
    load(fullfile(dirName, fileName));  % load I and Ibtsp
 
    % -------------------------
    % load simulation file
    % -------------------------
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
    load(fullfile(dirName, fileName));  % load dataSim
    % ---------------

    x = 0;
     for ii = 1:numel(BIN) % choose bin size

         for jj = 1:numel(WINDOW)    % choose window size

            for kk = 1:numel(OFFSET);   % choose offset
                x = x+1;
                conv = squeeze(sim.Converge(uu,jj,kk,ii,:));
                step(ff,x,:) = [nanmean(conv) nanstd(conv)]';
                invStep(ff,x) = 1/nanmean(conv);
                info(ff,x) = I(uu,jj,kk,ii);
                
            end
        end
     end
     tmp = corrcoef(info, invStep);
     r(ff) = tmp(1,2);
end