clear; clc;
dirs = dir_opts_REPOSITORY;
savefigs=0;
dirfigs='/media/WDDATA/BMIproject_svn/documentation/2012-07/';
%~~~~~~~~~~~~~~~~~
% lists of options
%~~~~~~~~~~~~~~~~~
% getsetList;
% getSimMixSetList;
% getSetListMomo;
getSim2DM1SetList;

% algos={'algo1','algo2a_ScaleYtoField','algo2c'};
% algos={'algo1','algo2a_ScaleYtoFieldNoShift','algo2c_ScaleYtoFieldNoShift'};
algos={'algo1','algo2a_ScaleYtoFieldNoShiftS','algo2c_ScaleYtoFieldNoShiftS'};
% algos={'algo2a0_ScaleYtoFieldNoShiftS','algo2s_ScaleYtoFieldNoShiftS'};

recs={'recsimmix','recsim2DM1','recsim2DM1_20ms','recsim2DM1_120ms'};
cals={'cal1_mindecod50b','cal1','cal1_min6stimsdecthres20','cal30'};
dynSys={'dynSys_damp13','dynSys_damp19','dynSys_damp25','dynSys_damp31','dynSys_damp37','dynSys1','dynSys_Gauss','dynSys_Dipole'};
simopt={'sim2','sim5'};

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% select from lists of options
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ffs=1:length(setList);
aas=[1 2 3];

rr = 3;
cc = 2;
dd = 1;
ss = 1;

nsim=100;
% nsim=320;
convall=nan(length(aas),length(ffs),nsim);

for ffi=1:length(ffs)
    ff=ffs(ffi);
    for aai=1:length(aas)
        aa=aas(aai);
        
        %~~~~~~~~~~~~~~~~~~~~
        % set opts structure
        %~~~~~~~~~~~~~~~~~~~~
        opts.set = setList{ff}
        opts.algo = algos{aa};
        opts.rec = recs{rr};
        opts.cal= cals{cc};
        opts.dynSys= dynSys{dd};
        opts.sim = simopt{ss};
        
        uu = 1; % set of SUs
        ii = 1; % bin
        jj = 1; % window
        kk = 1; % offset
        
        % -------------------------
        % load simulation file
        % -------------------------
        [dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
        load(fullfile(dirName, fileName));
        convall(aa,ffi,:)= squeeze(sim.Converge(uu,jj,kk,ii,:));

    end;
end;
    
convrate =100*sum(~isnan(convall),3)/nsim;
nbstpavg =nanmean(convall,3);
nbstpstd =nanstd(convall,0,3);

% %% bar plots of convergence rate
% 
% figure;
% for ffi=1:length(ffs)
%     subplot(3,4,ffi)
%     ff=ffs(ffi);
%     bar(convrate(:,ffi));
%     ylim([0 100])
%     title(strrep(setList{ff},'_','-'))
% end;
% 
% 
% %% boxplot of number of steps to convergence
% figure;
% for ffi=1:length(ffs)
%     subplot(3,4,ffi)
%     ff=ffs(ffi);
%     boxplot(squeeze(convall(:,ffi,:))');
%     ylim([0 200])
%     title(strrep(setList{ff},'_','-'))
% end;
% 
% %% bar+error plots of number of steps to convergence
% 
% figure;
% for ffi=1:length(ffs)
%     subplot(3,4,ffi)
%     ff=ffs(ffi);
%     bar(nbstpavg(:,ffi)); hold on;
%     errorbar(nbstpavg(:,ffi),nbstpstd(:,ffi),'rx','linewidth',3)
%     ylim([0 200])
%     title(strrep(setList{ff},'_','-'))
% end;

%%

% datatit={'gamma=0','gamma=25%','gamma=50%','gamma=75%','gamma=80%','gamma=85%','gamma=90%','gamma=95%','1 noisy electrode','2 noisy electrodes','Noisy stimulus 1 intensity 1','Noisy stimulus 1, all 3 intensities'};
% datatit={'4 stimuli','x3 intensities','x2 by combining electrodes','all'};
% datatit={'1 noisy electrode','Noisy stimulus 1'};
datatit={'gamma=0', 'gamma=50%','gamma=75%','gamma=80%','gamma=85%','gamma=90%'};

figure; set(gcf,'pos',[491         215        1146         733])
for ffi=1:length(ffs)
%     h(ffi)=subplot(3,4,ffi);
h(ffi)=subplot(2,3,ffi);
    ff=ffs(ffi);
    bar([convrate(:,ffi) nbstpavg(:,ffi)]); hold on;
    errorbar((1:length(aas))+.15,nbstpavg(:,ffi),nbstpstd(:,ffi),'rx','linewidth',2)
    ylim([0 110])
    title(datatit{ffi},'fontweight','bold')
% title(strrep(setList{ffs(ffi)}(9:end),'_','-'),'fontweight','bold')

    grid on;
    
    if ffi==4
        set(gca,'fontsize',12,'fontweight','bold')
        set(gca,'xticklabel',{'PCA','decoding','MDS proj'})
% set(gca,'xticklabel',{'PCA','decoding'})
        rotateticklabel(gca,45);
    else
        set(gca,'xticklabel','','yticklabel','');
    end;
    
end;

legend({'conv rate (%)','# steps to conv'})


%%
    
fname='perfnoisegamma';
% fname='perfnoiseel';

set(gcf, 'PaperPositionMode', 'auto')
saveas(gcf,fullfile(dirfigs,[fname '.png']));
% plot2svg(fullfile(dirfigs,[fname '.svg']))
