clear; clc;
dirs = dir_opts_REPOSITORY;
% savefigs=1;
dirfigs='/media/WDDATA/BMIproject_svn/documentation/2012-07/';
%~~~~~~~~~~~~~~~~~
% lists of options
%~~~~~~~~~~~~~~~~~

dynSys={'dynSys_damp13','dynSys_Gauss','dynSys_Dipole'};
simopt={'sim5'};

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% select from lists of options
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dd = 3;
ss = 1;

%~~~~~~~~~~~~~~~~~~~~
% set opts structure
%~~~~~~~~~~~~~~~~~~~~
opts.dynSys= dynSys{dd};
opts.sim = simopt{ss};

%~~~~~~~~~~~~~~~~~~~~
% LOAD CORRESPONDING DATA
%~~~~~~~~~~~~~~~~~~~~
% -------------------------
% load parameters
% -------------------------
dynSys_opts = dynSys_opts_REPOSITORY(opts.dynSys);
Xrange = dynSys_opts.Xrange;
Yrange = dynSys_opts.Yrange;
Radius = dynSys_opts.radius;

% -------------------------
% load simulation file
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'sim_idealFF');
load(fullfile(dirName, fileName));
PerfLabel = {'rate of convergences', 'number of steps to convergence'};
Converge = sim.Converge;
nbconv =round(100*sum(~isnan(Converge(:)))/length(Converge(:)));
nbstp =round(mean(Converge(~isnan(Converge))));
TestState=sim.State;


%% plot live trajectories

plot_traj_live



%%

ax=Xrange(1):5:Xrange(2);
ax_hd=Xrange(1):.5:Xrange(2);

X=zeros(length(ax));
Y=zeros(length(ax));
Fx=zeros(length(ax));
Fy=zeros(length(ax));

F=nan(2,length(ax),length(ax));
for xi=1:length(ax)
    x=ax(xi);
    for yi=1:length(ax)
        y=ax(yi);
        
        P=[x; y];

        Ftmp=dynSys_opts.FF(P);
        
        Fx(xi,yi)=Ftmp(1);
        Fy(xi,yi)=Ftmp(2);
        X(xi,yi)=x;
        Y(xi,yi)=y;
    end;
end;

X_hd=zeros(length(ax_hd));
Y_hd=zeros(length(ax_hd));
Fx_hd=zeros(length(ax_hd));
Fy_hd=zeros(length(ax_hd));
F_hd=nan(2,length(ax_hd),length(ax_hd));
Pdip_hd=nan(length(ax_hd),length(ax_hd));

for xi=1:length(ax_hd)
    x=ax_hd(xi);
    for yi=1:length(ax_hd)
        y=ax_hd(yi);
        
        P=[x; y];
        
        Ftmp=dynSys_opts.FF(P);
        Pdip_hd(xi,yi)=dynSys_opts.FFpot(P);
        
        Fx_hd(xi,yi)=Ftmp(1);
        Fy_hd(xi,yi)=Ftmp(2);
        X_hd(xi,yi)=x;
        Y_hd(xi,yi)=y;
    end;
end;

%%
figure; 
imagesc(ax,ax,Pdip_hd'); 
caxis(0.8*max(abs(caxis))*[-1 1]); colorbar;
set(gca,'ydir','normal'); 
hold on;
h=quiver(X,Y,Fx,Fy);
axis square
set(h,'linewidth',1,'color','k');
set(gcf,'color',[1 1 1])

fname=['IdealFF_Dipole'];
set(gcf, 'PaperPositionMode', 'auto')
saveas(gcf,fullfile(dirfigs,[fname '.png']));

%%
figure

plotTrajectories(TestState(:,:,1:2),[]); 
axis(max(Xrange)*[-1 1 -1 1])
axis square

