clear; clc;
dirs = dir_opts_REPOSITORY;
savefigs=0;
dirfigs='/media/TOSHDATA_/BMIproject_svn/documentation/2012-07/';
%~~~~~~~~~~~~~~~~~
% lists of options
%~~~~~~~~~~~~~~~~~
% getsetList;
% getSimMixSetList;
% getSetListMomo;
getSim2DM1SetList;

% algos={'algo1','algo2a_ScaleYtoField','algo2c'};
% algos={'algo1','algo2a_ScaleYtoFieldNoShift','algo2c_ScaleYtoFieldNoShift'};
% algos={'algo1','algo2a_ScaleYtoFieldNoShiftS','algo2c_ScaleYtoFieldNoShiftS'};
algos={'algo2a0_ScaleYtoFieldNoShiftS','algo2s_ScaleYtoFieldNoShiftS'};

recs={'recsimmix','recsim2DM1','recsim2DM1_20ms','recsim2DM1_120ms'};
cals={'cal1_mindecod50b','cal1','cal1_min6stimsdecthres20','cal30'};
dynSys={'dynSys_damp13','dynSys_damp19','dynSys_damp25','dynSys_damp31','dynSys_damp37','dynSys1','dynSys_Gauss','dynSys_Dipole'};
simopt={'sim2','sim5'};

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% select from lists of options
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ff = 1; 
aa = 1; 

% figure;
% % ffs=8+(1:4);
% ffs=1:3;
% % ffs=[4 11 12];
% aas=2:4;
% % aas=[1]
% 
% for ffi=1:length(ffs)
%     ff=ffs(ffi);
% %     convall=nan(length(aas),160);
% %     subplot(1,length(ffs),ffi);
%     for aai=1:length(aas)
%         aa=aas(aai);
%         subplot(length(aas),length(ffs),length(ffs)*(aai-1)+ffi);


rr = 4;
cc = 4;
dd = 8;
ss = 2;

%~~~~~~~~~~~~~~~~~~~~
% set opts structure
%~~~~~~~~~~~~~~~~~~~~
opts.set = setList{ff}
opts.algo = algos{aa};
opts.rec = recs{rr};
opts.cal= cals{cc};
opts.dynSys= dynSys{dd};
opts.sim = simopt{ss};

uu = 1; % set of SUs
ii = 1; % bin
jj = 1; % window
kk = 1; % offset

%~~~~~~~~~~~~~~~~~~~~
% LOAD CORRESPONDING DATA
%~~~~~~~~~~~~~~~~~~~~
% -------------------------
% load parameters
% -------------------------
rec_opts = rec_opts_REPOSITORY(opts.rec);
BIN = rec_opts.bin;
WINDOW = rec_opts.window;
OFFSET = rec_opts.offset;

dynSys_opts = dynSys_opts_REPOSITORY(opts.dynSys);
Xrange = dynSys_opts.Xrange;
Yrange = dynSys_opts.Yrange;
Radius = dynSys_opts.radius;

% -------------------------
% load calibration file
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'cal');
load(fullfile(dirName, fileName));
ntrials=cal.testntrials;
nstims=length(cal.testntrials);
Forces=squeeze(cal.ForceTest(uu,jj,kk,ii,:,:,:));
RecPoint=double(squeeze(cal.RecPoint(uu,jj,kk,ii,:,:)));
RecF=squeeze(cal.RecForce(uu,jj,kk,ii,:,:));
if strcmp(opts.algo(1:5),'algo2')
    ax=cal.dispfield{uu,jj,kk,ii}.ax;
    dispfield=cal.dispfield{uu,jj,kk,ii};
    sensfield=dispfield.sensfield;
else
    TRI = delaunay(double(RecPoint(:,1)),double(RecPoint(:,2)));
    ax=Xrange(1):.2:Xrange(2);
    sensfield=nan(length(ax));
    for x = 1:length(ax)
        for y = 1:length(ax)
            nearest = dsearch(RecPoint(:,1),RecPoint(:,2),TRI,ax(x),ax(y));
            sensfield(y,x)=nearest;
        end
    end
end;

% -------------------------
% load simulation file
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
load(fullfile(dirName, fileName));
PerfLabel = {'rate of convergences', 'number of steps to convergence'};
Converge = squeeze(sim.Converge(uu,jj,kk,ii,:));
nbconv =round(100*sum(~isnan(Converge(:)))/length(Converge(:)));
nbstp =round(mean(Converge(~isnan(Converge))));
TestState=squeeze(sim.State(uu,jj,kk,ii,:,:,:));
TestForce=squeeze(sim.Force(uu,jj,kk,ii,:,:,:));
TestStim=squeeze(sim.Stimulation(uu,jj,kk,ii,:,:));

% -------------------------
% load simulation file IDEAL FF
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'sim_idealFF');
load(fullfile(dirName, fileName));
Converge = sim.Converge;
nbconv0 =round(100*sum(~isnan(Converge(:)))/length(Converge(:)));
nbstp0 =round(mean(Converge(~isnan(Converge))));
TestState0=sim.State;

% distance point by point between ideal and actual trajectories
dpp=sqrt(sum((TestState(:,:,1:2)- TestState0(:,:,1:2)).^2,3));
% average distances between ideal and actual trajectories
dm=mean(dpp,2);

%% 2DM1: plot average number of spikes triggered by each stimulus

plot_AvgSpkNb_2DM1
% % fname=['AvgSpkNb_Patter_' opts.set];
% fname=['AvgSpkNb_rec_' opts.set]; 
% 
% set(gcf, 'PaperPositionMode', 'auto')
% saveas(gcf,fullfile(dirfigs,[fname '.png']));
%% plot average number of spikes recorded with the 2DM1 simulated data


plot_PSTH_2DM1
% 
set(gcf,'pos',[255   291   860   560])
fname=['AvgSpkNb_' opts.set];
set(gcf, 'PaperPositionMode', 'auto')
saveas(gcf,fullfile(dirfigs,[fname '.png']));
% % saveas(gcf,fullfile(dirfigs,[fname '.pdf']));
% % saveas(gcf,fullfile(dirfigs,[fname '.png']));
% % plot2svg(fullfile(dirfigs,[fname '.svg']))

%% plot PSTHs

% plot_PSTH

%%
figure; set(gcf,'pos',[261         137        1246         811])
plot_MDSproj_algo2;
fname=['MDSproj_' opts.set];

set(gcf, 'PaperPositionMode', 'auto')
saveas(gcf,fullfile(dirfigs,[fname '.png']));
%% Plot sensory regions
figure; set(gcf,'pos',[261         137        1246         811])
plot_SensoryRegs
title(strrep(opts.set,'_','-'))
fname=['SensRegAlgo2_' opts.set];
set(gcf, 'PaperPositionMode', 'auto')
% saveas(gcf,fullfile(dirfigs,[fname '.png']));
%% plot Force vectors from the test set 

plot_forces

%% plot live trajectories

plot_traj_live

%% plot trajectories superimposed on the sensory field
figure
traj_trials=1:320; 
plot_traj_sensfield
title([num2str(nbconv) '% conv in ' num2str(nbstp) ' stps'])

%% plot *actual* and *ideal* trajectories superimposed on the sensory field

figure;

% plot sensory regions

imagesc(ax,ax,sensfield);
cmap=winter(nstims);
cmap=cmap(randperm(nstims),:);
colormap(cmap)
set(gca,'ydir','normal')
hold on;
axis square
traj_trials=1:size(TestState0,1); 

hold on;
 sim_opts=sim_opts_REPOSITORY(opts.sim);
 nInitPos=sim_opts.nRun/sim_opts.nperpos;
 cmap2=autumn(nInitPos);
 cmap2=cmap2(randperm(nInitPos),:);

 set(gca,'ydir','normal');
 
 for tt1=1:sim_opts.nperpos
     for tt2=1:nInitPos
         tt=(tt1-1)*nInitPos+tt2;
         X0=squeeze(TestState0(traj_trials(tt),:,1:2));
         X=squeeze(TestState(traj_trials(tt),:,1:2));
         %     plot(X0(:,1), X0(:,2),'k-','linewidth',2);
         plot(X(:,1), X(:,2),'-','col',cmap2(tt2,:),'linewidth',2);
         %     pause(.1)
     end;
 end;
    
for tt=1:length(traj_trials)
    X0=squeeze(TestState0(traj_trials(tt),:,1:2));
    X=squeeze(TestState(traj_trials(tt),:,1:2));
    plot(X0(:,1), X0(:,2),'k-','linewidth',2);
%     plot(X(:,1), X(:,2),'r-','linewidth',2);
%     pause(.1)
end;

set(gca,'xtick',[],'ytick',[]); 
axis(max(Xrange)*[-1 1 -1 1])
axis square
% display performances
title(['D=' num2str(mean(dm))])

% fname=['Traj_' opts.set '_' opts.algo '_' opts.dynSys '_' ];
% set(gcf, 'PaperPositionMode', 'auto')
% saveas(gcf,fullfile(dirfigs,[fname '.png']));
%%
% % set(gcf,'pos',[29         485        1649         438]);
% % set(gcf,'pos',[29         485        1649         877]);
% 
% % fname=['Traj_' opts.set];
% % fname=['SensReg_' opts.set '_' opts.algo];
% 
% set(gcf, 'PaperPositionMode', 'auto')
% % saveas(gcf,fullfile(dirfigs,[fname '.pdf']));
% saveas(gcf,fullfile(dirfigs,[fname '.png']));
% % plot2svg(fullfile(dirfigs,[fname '.svg']))
