setrootdir;
getsetList;

opts.cal='cal1';
opts.algo = 'algo1';
opts.dynSys = 'dynSys1';
opts.sim = 'sim1';

% -------------------------
% load sampling parameters
% -------------------------
opts.rec = 'rec0offwin';
rec_opts = rec_opts_REPOSITORY(opts.rec);
BINoffwin = rec_opts.bin;
WINDOWoffwin = rec_opts.window;
OFFSEToffwin = rec_opts.offset;

opts.rec = 'rec0bin';
rec_opts = rec_opts_REPOSITORY(opts.rec);
BINbin = rec_opts.bin;
WINDOWbin = rec_opts.window;
OFFSETbin = rec_opts.offset;
% -------------------------

% ff = 1; % data set
uu = 1; % set of units
ii = 1; % bin
% jj = 1; % window
kk = 1; % offset

PerfLabels = {'percentage of convergences (chance level substracted)'};
Perf = NaN(length(setList), length(WINDOWoffwin), length(OFFSEToffwin),length(BINbin));
MIFopt = {'FxFy0','RT0','AC0'}; infotyp='infoForceFromTraj';
% MIFopt = {'FxFy1','RT1','AC1'}; infotyp='infoForce';
MI{1}=nan(length(setList),length(WINDOWoffwin), length(OFFSEToffwin),length(BINbin));
MI{2}=nan(length(setList),length(WINDOWoffwin), length(OFFSEToffwin),length(BINbin));
MI{3}=nan(length(setList),length(WINDOWoffwin), length(OFFSEToffwin),length(BINbin));

opts.rec = 'rec0offwin';
for ff=1:length(setList)
    opts.set = setList{ff};
    opts.cal='calrand1';
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
    load(fullfile(dirName, fileName));
    simrand=sim;
    opts.cal='cal1';
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
    load(fullfile(dirName, fileName));
    for jj=1:length(WINDOWoffwin),
        for kk=1:length(OFFSEToffwin),
            Converge=squeeze(sim.Converge(uu,jj,kk,1,:));
            Convergerand=squeeze(simrand.Converge(uu,jj,kk,1,:));
            nbconv=round(100*sum(~isnan(Converge))/length(Converge));
            nbconvrand=round(100*sum(~isnan(Convergerand))/length(Convergerand));
            Perf(ff,jj,kk,2)=nbconv-nbconvrand;
        end;
    end;
    
    for mm=1:length(MIFopt)
        opts.MIForce = MIFopt{mm};
        [dirName, fileName] = file_opts_REPOSITORY(opts, infotyp);
        load(fullfile(dirName, fileName));  % load I and Ibtsp
        MI{mm}(ff,:,:,2)=squeeze(I(uu,:,:,1));
    end;
end;

opts.rec = 'rec0bin';
for ff=1:length(setList)
    opts.set = setList{ff};
    opts.cal='calrand1';
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
    load(fullfile(dirName, fileName));
    simrand=sim;
    opts.cal='cal1';
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
    load(fullfile(dirName, fileName));
    for ii=1:length(BINbin),
        Converge=squeeze(sim.Converge(uu,1,1,ii,:));
        Convergerand=squeeze(simrand.Converge(uu,1,1,ii,:));
        nbconv=round(100*sum(~isnan(Converge))/length(Converge));
        nbconvrand=round(100*sum(~isnan(Convergerand))/length(Convergerand));
        Perf(ff,end,1,ii)=nbconv-nbconvrand;
    end;
    
    for mm=1:length(MIFopt)
        opts.MIForce = MIFopt{mm};
        [dirName, fileName] = file_opts_REPOSITORY(opts, infotyp);
        load(fullfile(dirName, fileName));  % load I and Ibtsp
        MI{mm}(ff,end,1,:)=squeeze(I(uu,1,1,:));
    end;
end;

% max across all combinations of params
perfall=reshape(Perf,[length(setList) length(WINDOWoffwin)*length(OFFSEToffwin)*length(BINbin)]);
perfall(:,isnan(perfall(1,:)))=[];
maxperf=max(perfall,[],2);
for mi=1:3,
    miall{mi}=reshape(MI{mi},[length(setList) length(WINDOWoffwin)*length(OFFSEToffwin)*length(BINbin)]);
    miall{mi}(:,isnan(miall{mi}(1,:)))=[];
    maxmi{mi}=max(miall{mi},[],2);
end;


%%
% th=50; idxrem=maxperf<th;
% S=sprintf('%d data sets never show a convergence rate above %d %%',sum(maxperf<th),th);

% th=.5; mi=1;
th=.1; mi=3;
idxrem=maxmi{mi}<th;
S=sprintf('%d data sets never have a MI %s that goes above %d %%',sum(maxmi{mi}<th),MIFopt{mi},th);

idxkeep=~idxrem;

figure;
set(gcf,'pos',[19         472        1610         408])
for mi=1:3,
    subplot(1,3,mi); hold on;
    plot(maxperf,maxmi{mi},'.');
    plot(maxperf(idxrem),maxmi{mi}(idxrem),'*r');
    xlabel('max CR'); ylabel(['max ' MIFopt{mi}]);
    grid on;
end;

[ax,h]=suplabel(S,'t',[.09 .11 .84 .84]);
set(h,'FontSize',15)

find(idxrem')
find(idxkeep')