clear; clc;

% getsetList;
getSimMixSetList;
% getSimulatedSetList;
dirs = dir_opts_REPOSITORY;
savefigs=0;

% data set
ff = 1;
bin = 10;
window = 500;
offset = 0;
nCal = 50;

% -------------------------
% select data set
% -------------------------
opts.set = setList{ff};
disp(opts.set)

% -------------------------
% load data
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
load(fullfile(dirName, fileName)); % load data and dataParams
ntrial=dataParams.trialN;
% [nt maxtrial nunit nstim] = size(data);

rawData = data;
clear data;
badstim=dataParams.trialN<60;
if isfield(dataParams,'stimPatterns') && ~isempty(dataParams.stimPatterns), dataParams.stimPatterns(badstim,:)=[]; end;
dataParams.trialN(badstim)=[];
rawData(:,:,:,badstim)=[];
[data tax]= createDataSet(rawData, [offset offset+window bin]);
data=data/(bin/1000);
[nt maxtrial nunit nstim] = size(data);

dataCal=data(:,1:nCal,:,:);
dataTst=data(:,nCal+1:min(dataParams.trialN),:,:);
nTst=dataParams.trialN-nCal;

% -------------------------
% compute firing rates
% -------------------------
frateallCal=squeeze(nanmean(dataCal,2));
frateSEMCal=squeeze(nanstd(dataCal,0,2))./sqrt(nCal);

frateallTst=squeeze(nanmean(dataTst,2));
frateSEMTst=squeeze(nanstd(dataTst,0,2));
for ss=1:4,
    frateSEMTst(:,:,ss)=frateSEMTst(:,:,ss)./sqrt(nTst(ss));
end;

% -------------------------
% plot firing rates
% -------------------------

figure

for uu=1:7 %1:nunit
% uu=14;

colz={'b','k'};
clf;
for ss=1:nstim
    
    h(ss)=subplot(ceil(sqrt(nstim)),ceil(sqrt(nstim)),ss); hold on;
    
    %     plot(tax,squeeze(frateallCal(:,uu,ss)),'-','linewidth',1,'color',colz{1});
    [ph,msg]=jbfill(tax,squeeze(frateallCal(:,uu,ss))'+squeeze(frateSEMCal(:,uu,ss))',squeeze(frateallCal(:,uu,ss))'-squeeze(frateSEMCal(:,uu,ss))',colz{1},colz{1},0,0.4);
    
    %     plot(tax,squeeze(frateallTst(:,uu,ss)),'-','linewidth',1,'color',colz{2});
    [ph,msg]=jbfill(tax,squeeze(frateallTst(:,uu,ss))'+squeeze(frateSEMTst(:,uu,ss))',squeeze(frateallTst(:,uu,ss))'-squeeze(frateSEMTst(:,uu,ss))',colz{2},colz{2},0,0.4);
    
    
    axis([0 window -10 300]); grid on;
    
end;

% -------------------------
% beautify
% -------------------------


for ss=1:nstim
    set(get(h(ss),'title'),'string',['stim ' num2str(ss)])
end;

for ss=[1 3]
    set(get(h(ss),'ylabel'),'string','spikes/s')
end;

for ss=[3 4]
    set(get(h(ss),'xlabel'),'string','time (ms)')
end;

for ss=[2 4]
    set(h(ss),'yticklabel','')
end;

for ss=[1 2]
    set(h(ss),'xticklabel','')
end;


set(gcf,'pos',[248         171        1194         663]);
[ax,ht]=suplabel(['set ' num2str(ff) ': ' strrep(opts.set,'_','-') '. unit=' num2str(uu) '. offset=' num2str(offset) 'ms. ' 'bin=' num2str(bin) 'ms ' '. window=' num2str(window) 'ms' '. Trials for calibration: ' num2str(nCal) '.']  ,'t',[.08 .13 .84 .84]);
set(ht,'FontSize',15)
subplot(h(2)); legend({'train','test'});
pause
end
if savefigs
    set(gcf,'color',[1 1 1]);
    set(gcf,'paperpositionmode','auto');

% set(gcf,'color','none')
% set(axes,'color','none')
    fname=['PSTH_' opts.set '_unit' num2str(uu) '_win' num2str(window) 'ms' '_off' num2str(offset) 'ms' '_bin' num2str(bin) 'ms' '_calibtrials' num2str(nCal)];
%     export_fig(fullfile(dirs.plotvar,[fname '.eps']));
%     saveas(gcf,fullfile(dirs.plotvar,fname),'fig');
print(gcf,'-dtiff','-r300',fullfile(dirs.plotvar,fname))

end;

%     pause;
% end;