clear; clc;

% getsetList;
getSimMixSetList
% getSimulatedSetList;
% getSim2DM1SetList
% getSetListMomo;

dirs = dir_opts_REPOSITORY;
savefigs=0;

% data set
ff = 1;
% for ff=1:length(setList)
bin = 5;
window = 500;
offset = 0;
nCal = 0;

% -------------------------
% select data set
% -------------------------
opts.set = setList{ff};
disp(opts.set)

% -------------------------
% load data
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
load(fullfile(dirName, fileName)); % load data and dataParams
ntrial=dataParams.trialN;

rawData = data;
clear data;
badstim=dataParams.trialN<30;
if isfield(dataParams,'stimPatterns') && ~isempty(dataParams.stimPatterns), dataParams.stimPatterns(badstim,:)=[]; end;
dataParams.trialN(badstim)=[];
rawData(:,:,:,badstim)=[];
[data tax]= createDataSet(rawData, [offset offset+window bin]); 
% tax=tax/1000;
data=data/(bin/1000);
[nt maxtrial nunit nstim] = size(data);

% -------------------------
% compute firing rates
% -------------------------

frateall=nan([nt nunit nstim]);
frateSEM=nan([nt nunit nstim]);
frateall(:,:,:)=squeeze(nanmean(data,2));
frateSEM(:,:,:)=squeeze(nanstd(data,0,2));
for ss=1:nstim,
    frateSEM(:,:,ss)=frateSEM(:,:,ss)./sqrt(ntrial(ss));
end;

% -------------------------
% plot firing rates
% -------------------------

figure(1)
stp=.8*max(frateall(:));
% stp=150;
colz='b';
clf;
for ss=1:nstim
    
    h(ss)=subplot(1,nstim,ss); hold on;
    
    for uu=1:nunit
%         [ph,msg]=jbfill(tax,stp*(uu-1)+squeeze(frateall(:,uu,ss))'+squeeze(frateSEM(:,uu,ss))',stp*(uu-1)+squeeze(frateall(:,uu,ss))'-squeeze(frateSEM(:,uu,ss))',colz,colz,0,0.4);
        plot(tax,stp*(uu-1)+squeeze(frateall(:,uu,ss))','k','linewidth',2);
        plot([0 window],stp*(uu-1)*[1 1],'k--')
    end;
    
    
    axis([0 max(tax) -0.2*stp stp*nunit]); 
    grid on;
    
end;

% -------------------------
% beautify
% -------------------------
for ss=1:nstim
    set(get(h(ss),'title'),'string',['stim ' num2str(ss)],'FontSize',12,'fontweight','bold')
    set(h(ss),'ytick',[]);
    tmp=get(h(ss),'pos');
    tmp(2)=tmp(2)-0.02;
    set(h(ss),'pos',tmp);
end;

set(get(h(1),'ylabel'),'string','spikes/s','FontSize',12,'fontweight','bold')
set(get(h(1),'xlabel'),'string','time (ms)','FontSize',12,'fontweight','bold')

set(gcf,'pos',[248         171        1194         663]);
[ax,ht]=suplabel(['set ' num2str(ff) ': ' strrep(opts.set,'_','-') '. bin=' num2str(bin) 'ms.']  ,'t',[.08 .13 .84 .84]);
set(ht,'FontSize',16,'fontweight','bold')

if savefigs
    set(gcf,'color',[1 1 1]);
    set(gcf,'paperpositionmode','auto');
    fname=['PSTH_' opts.set '_bin' num2str(bin) 'ms'];
    print(gcf,'-dtiff','-r100',fullfile(dirs.plotvar,fname)) 
%     saveas(gcf,fullfile(dirs.plotvar,fname),'fig')
%     plot2svg([fullfile(dirs.plotvar,fname) '.svg'],gcf)
    
end;
% end

% %% fit exponential to autocorrelogram of the psth
% 
% uu=6;
% ss=2;
% 
% twin=[1 1000];
% [~, tidx1]=min(abs(twin(1)-tax));
% [~, tidx2]=min(abs(twin(2)-tax));
% 
% twinb=[1 50];
% [~, tidx1b]=min(abs(twinb(1)-tax));
% [a tidx2b]=min(abs(twinb(2)-tax));
% 
% psth=squeeze(frateall(tidx1:tidx2,uu,ss));
% tax2=tax(tidx1:tidx2);
% 
% c=xcorr(psth,'coeff');
% c=c((length(c)-1)/2+1:end)';
% tax2b=tax(tidx1b:tidx2b);
% [estimates, model] = fitcurvedemo(tax2b,c(tidx1b:tidx2b));
% 
% figure
% subplot(1,2,1);
% plot(tax2,psth);
% ylabel('spk/s'); 
% xlabel('time (ms)')
% title('PSTH')
% 
% subplot(1,2,2);
% plot(tax2, c, '*')
% hold on
% [sse, FittedCurve] = model(estimates);
% plot(tax2b, FittedCurve, 'r')
%  
% xlabel('time')
% ylabel('PSTH autocorr')
% title(['Fitting to exp (T=' num2str(round(1/estimates(2))) 'ms)']);
% legend('data', ['fit using ', func2str(model)])
% hold off
% 
% 
% %% fit gaussian to autocorrelogram of the psth
% 
% uu=6;
% ss=2;
% 
% 
% 
% psth=squeeze(frateall(:,uu,ss));
% 
% c=xcorr(psth,'coeff');
% tax2=[-fliplr(tax(1:end-1)) 0 tax(1:end-1)]';
% 
% twinb=[-10 10];
% [~, tidx1b]=min(abs(twinb(1)-tax2));
% [~, tidx2b]=min(abs(twinb(2)-tax2));
% 
% [estimates, model] = fitcurvedemo2(tax2(tidx1b:tidx2b),c(tidx1b:tidx2b));
% 
% figure
% subplot(1,2,1);
% plot(tax,psth);
% ylabel('spk/s'); 
% xlabel('time (ms)')
% title('PSTH')
% 
% subplot(1,2,2);
% plot(tax2, c, '*')
% hold on
% [sse, FittedCurve] = model(estimates);
% plot(tax2(tidx1b:tidx2b), FittedCurve, 'r')
%  
% xlabel('time')
% ylabel('PSTH autocorr')
% title(['Fitting to exp (T=' num2str(round(sqrt(1/(2*estimates(2))))) 'ms)']);
% legend('data', ['fit using ', func2str(model)])
% hold off