clear; clc;

getsetList;
% getSimMixSetList
% getSimulatedSetList;
% getSim2DM1SetList

dirs = dir_opts_REPOSITORY;
savefigs=0;

ss=1;
Favg=cell(1,4);
% data set
% ff = 30;
for ff=1:length(setList)
    bins=[10 20 50 100];
    
    window = 1000;
    offset = 0;
    nCal = 0;
    
    % -------------------------
    % select data set
    % -------------------------
    opts.set = setList{ff};
    disp(opts.set)
    
    % -------------------------
    % load data
    % -------------------------
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
    load(fullfile(dirName, fileName)); % load data and dataParams
    ntrial=dataParams.trialN;
    rawData = data;
    clear data;
    badstim=dataParams.trialN<60;
    if isfield(dataParams,'stimPatterns') && ~isempty(dataParams.stimPatterns), dataParams.stimPatterns(badstim,:)=[]; end;
    dataParams.trialN(badstim)=[];
    rawData(:,:,:,badstim)=[];
    
    for bb = 1:length(bins)
        bin=bins(bb);
        [data tax]= createDataSet(rawData, [offset offset+window bin]);
        [nt maxtrial nunit nstim] = size(data);
        F=squeeze(var(data(:,1:ntrial(ss),:,ss),0,2)./mean(data(:,1:ntrial(ss),:,ss),2));
        Fall{ff,bb}=F;
        Favg{bb}=[Favg{bb} nanmean(F,1)];
    end;
end;

%%
figure;
edges=0:0.15:6;
for bb = 1:length(bins)
    subplot(2,2,bb)
    N=histc(Favg{bb},edges);
    bar(edges,N,'histc')
%     hist(Favg{bb},50);
    title(['temp res = ' num2str(bins(bb)) 'ms,  mean(F)=' num2str(nanmean(Favg{bb}))])
    xlim([0 6]); ylim([0 220])
end;

    if savefigs
        set(gcf,'color',[1 1 1]);
        set(gcf,'paperpositionmode','auto');
        fname=['PSTH_AvgFanoFactor stim' num2str(ss)];
        print(gcf,'-dtiff','-r100',fullfile(dirs.plotvar,fname)) 
    end;

%%

figure(1);

for ff=1:length(setList)
    for bb=1:length(bins),
        subplot(2,2,bb);
        imagescnan(Fall{ff,bb}');
        caxis([0 5])
        title(['temp res = ' num2str(bins(bb)) 'ms,  mean(F)=' num2str(nanmean(Fall{ff,bb}(:)))])
        colorbar
        set(gca,'ydir','normal')
    end;
    
    
    if savefigs
        set(gcf,'color',[1 1 1]);
        set(gcf,'paperpositionmode','auto');
        fname=['PSTH_' setList{ff} 'FanoFactor stim' num2str(ss)];
        print(gcf,'-dtiff','-r100',fullfile(dirs.plotvar,fname))
        %     saveas(gcf,fullfile(dirs.plotvar,fname),'fig')
        %     plot2svg([fullfile(dirs.plotvar,fname) '.svg'],gcf)
        
    end;
    
    %     pause;
    clf;
end;


