clear; clc;

getsetList;
% getSimMixSetList
% getSimulatedSetList;
% getSim2DM1SetList

dirs = dir_opts_REPOSITORY;
savefigs=0;

ss=1;
% data set
% ff = 30;
bin=20;

Favg=[];  Fall=[]; Vall=[]; Mall=[];
for ff=1:length(setList)
    
    window = 1000;
    offset = 0;
    nCal = 0;
    
    % -------------------------
    % select data set
    % -------------------------
    opts.set = setList{ff};
    disp(opts.set)
    
    % -------------------------
    % load data
    % -------------------------
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
    load(fullfile(dirName, fileName)); % load data and dataParams
    ntrial=dataParams.trialN;
    rawData = data;
    clear data;
    badstim=dataParams.trialN<60;
    if isfield(dataParams,'stimPatterns') && ~isempty(dataParams.stimPatterns), dataParams.stimPatterns(badstim,:)=[]; end;
    dataParams.trialN(badstim)=[];
    rawData(:,:,:,badstim)=[];
    
    
    [data tax]= createDataSet(rawData, [offset offset+window bin]);
    [nt maxtrial nunit nstim] = size(data);
    V=squeeze(var(data(:,1:ntrial(ss),:,ss),0,2));
    M=squeeze(mean(data(:,1:ntrial(ss),:,ss),2));
    F=V./M;
    
    Fall=[Fall F];
    Vall=[Vall V];
    Mall=[Mall M];
    Favg=[Favg nanmean(F,1)];
    
end;

%%
figure;
edges=0:0.15:6;
N=histc(Favg,edges);
bar(edges,N,'histc')
xlim([0 6]); ylim([0 220])

if savefigs
    set(gcf,'color',[1 1 1]);
    set(gcf,'paperpositionmode','auto');
    fname=['PSTH_AvgFanoFactor stim' num2str(ss)];
    print(gcf,'-dtiff','-r100',fullfile(dirs.plotvar,fname))
end;

%%

figure; 

Mavg=mean(Mall,1);
Vavg=mean(Vall,1);

%remove completely unresponsive units
idx=find(Mavg==0);
Mavg(idx)=[];
Vavg(idx)=[];
[~, I] = sort(Vavg); 
Vavg=Vavg(I);
Mavg=Mavg(I);

Y=log(Mavg);
X=log(Vavg);
plot(X,Y,'.')
% xlim(ylim)

[estimates, model] = fitcurvedemo3(X,Y);
[sse, FittedCurve] = model(estimates);

hold on;
plot(X([1 end]),FittedCurve([1 end]),'-r','linewidth',2)
xlabel('log(\sigma^2)')
ylabel('log(\mu)')
legend({'data (each point represent a neuron)',['fit : \sigma^2=\alpha\mu^\beta with \alpha=' num2str(round(100*exp(estimates(2)))/100) ' and \beta=' num2str(round(100*estimates(1))/100)]},'location','southeast')
title(['variability in the spike count sampled at a ' num2str(bin) 'ms resolution'])
axis square
grid on
% sprintf('fit : \sigma^2=\alpha\mu^\beta with \alpha= %0.2g and
% \beta=%0.2g',round(100*exp(estimates(2)))/100,round(100*estimates(1))/100
% )

if savefigs
    set(gcf,'color',[1 1 1])
    fname='CurrBiolReply_SpikVar';
    export_fig(fullfile(dirs.plotvar,[fname '.eps']));
    saveas(gcf,fullfile(dirs.plotvar,fname),'fig');
    close;
end;
