clear; clc;

getsetList;
% getSimMixSetList
% getSimulatedSetList;
% getSim2DM1SetList

dirs = dir_opts_REPOSITORY;
savefigs=0;

% sets=[5 28 35];
% nrns=[1 2 3; 1 2 3; 4 7 13];

sets=[5 24 35];
nrns=[1 2 3; 5 11 12; 4 7 13];

figure;

% data set
for ffi=1:length(sets)
    ff = sets(ffi);
    
    % -------------------------
    % select data set
    % -------------------------
    opts.set = setList{ff};
    disp(opts.set)
    
    % -------------------------
    % load data
    % -------------------------
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
    load(fullfile(dirName, fileName)); % load data and dataParams
    ntrial=dataParams.trialN;
    
    rawData = data;
    clear data;
    badstim=dataParams.trialN<60;
    if isfield(dataParams,'stimPatterns') && ~isempty(dataParams.stimPatterns), dataParams.stimPatterns(badstim,:)=[]; end;
    dataParams.trialN(badstim)=[];
    rawData(:,:,:,badstim)=[];
    [nt maxtrial nunit nstim] = size(rawData);
    tax=0:nt-1;
    
    
    frateall=zeros([nt size(nrns,2) nstim]);
    R2=ones(1,25)/25;
    
    % lambda=250;
    % x=0:0.001:0.020;
    % E=lambda*exp(-lambda*x);
    % E=[zeros(1,length(E)-1) E];
    % hw=(length(E)-1)/2;
    
    for uu=1:size(nrns,2)
        for ss=1:nstim
            
            for ii=1:ntrial(ss)
                tmp=1000*conv(R2,squeeze(rawData(:,ii,nrns(ffi,uu),ss)));
                tmp(1:(length(R2)-1)/2)=[];
                tmp(end-(length(R2)-1)/2+1:end)=[];
                
                %             tmp= conv(squeeze(rawData(:,ii,nrns(ffi,uu),ss)),E);
                %             tmp=tmp(hw+1:hw+nt);
                
                frateall(:,uu,ss)=frateall(:,uu,ss)+tmp*(1/ntrial(ss));
            end;
        end;
    end;
    
    % -------------------------
    % plot firing rates
    % -------------------------
    
    for nn=1:3
        %         uu=nrns(ffi,nn);
        h(ffi,nn)=subplot(3,3,(ffi-1)*3+nn); hold on;
        colz={'r','g','m','b'};
        for ss=1:nstim
            plot(tax,squeeze(frateall(:,nn,ss))',colz{ss},'linewidth',2);
        end;
        ylim([0 max(frateall(:))])
    end;
    
end;

legend({'stimulus 1','stimulus 2','stimulus 3','stimulus 4'},'location','northeast')

% -------------------------
% beautify
% -------------------------
for nn=1:3
    set(get(h(1,nn),'title'),'string',['neuron ' num2str(nn)]);
    set(get(h(3,nn),'xlabel'),'string','time (ms)');
    set(h(1,nn),'xtick',[]);
    set(h(2,nn),'xtick',[]);
end;

for ffi=1:length(sets)
    set(get(h(ffi,1),'ylabel'),'string','spikes/s');
    set(h(ffi,2),'ytick',[]);
    set(h(ffi,3),'ytick',[]);
end;

set(gcf,'pos',[364         240        1196         708])

if savefigs
    set(gcf,'color',[1 1 1])
    fname='CurrBiolReply_PSTHs';
    export_fig(fullfile(dirs.plotvar,[fname '.eps']));
    saveas(gcf,fullfile(dirs.plotvar,fname),'fig');
    close;
end;

