clear; clc;
dirs = dir_opts_REPOSITORY;
savefigs=0;

getsetList;

% data set
ffs=36;
% ffs=23;

for ff=ffs
    
    % -------------------------
    % select data set
    % -------------------------
    opts.set = setList{ff};
    disp(opts.set)
    
    % -------------------------
    % load data
    % -------------------------
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
    load(fullfile(dirName, fileName)); % load data and dataParams
    ntrial=dataParams.trialN;
    data=data(:,:,:,ntrial>50);
    ntrial=ntrial(ntrial>50);
    [nt maxtrial nunit nstim] = size(data);
    
    figure;
    clear hp;
    
    for ss=1:4;
        hp(ss)=subplot(2,2,ss);
        hold on;
        colz={'r','c','g','b'};
        %         maxtmp=0; mintmp=100;
        spksum=squeeze(nansum(nansum(data(:,1:ntrial(ss),:,ss),1),3));
        movavg=filtfilt([1 2 5 10 12 10 5 2 1]/48,1,double(spksum));
        plot(movavg,'linewidth',2,'color',colz{ss});
        [ph,msg]=jbfill(1:length(movavg),movavg+std(spksum),movavg-std(spksum),colz{ss},colz{ss},0,0.3);
        plot(1:length(spksum),spksum,['.k'],'MarkerSize',5);
        
        %         maxtmp=max([maxtmp max(spksum)]);
        %         mintmp=min([mintmp min(spksum)]);
        %         ylim([mintmp-0.1 maxtmp+0.1])
        ylim([0 1000])
        %         xlim([1 maxtrial])
        xlim([0 200])
        grid on
        title(['stim ' num2str(ss)])
    end;
    
    %
    set(gcf,'pos',[259         304        1222         504]);
    for ii=1:length(hp)-2,
        set(hp(ii),'xticklabel','')
    end;
    
    set(get(hp(3),'ylabel'),'string','spike count')
    set(get(hp(3),'xlabel'),'string','sweep')
    
    [ax,h]=suplabel(['set ' num2str(ff) ': ' strrep(opts.set,'_','-')]  ,'t',[.08 .13 .84 .84]);
    set(h,'FontSize',15)
    
    if savefigs
        set(gcf,'color',[1 1 1])
        set(gcf,'paperpositionmode','auto');
        fname=['stationarity_' opts.set];
        
        %             export_fig(fullfile(dirs.plotvar,[fname '.eps']));
        %     saveas(gcf,fullfile(dirs.plotvar,fname),'fig');
        print(gcf,'-dtiff','-r150',fullfile(dirs.plotvar,fname))
        close;
    end;
end;
