clear; clc;

% getsetList;
% getSimMixSetList;
getSim2DM1SetList;
% getSetListMomo;

dirs = dir_opts_REPOSITORY;
savefigs=0;

% opts.dist='dist_120ms';
opts.dist='dist2';

% MDScriterion={'metricstress','metricsstress','sammon','strain','sstress'};
MDScriterion={'strain'};
opts.MDScriterion=MDScriterion{1};
dist_opts = dist_opts_REPOSITORY(opts.dist);
TETA = round(180*dist_opts.teta/pi);
TC = dist_opts.tc;

%%
ff=1;
opts.set = setList{ff};
[dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
load(fullfile(dirName, fileName));  % load data and dataParams;
trialN=dataParams.trialN;
figure: imagesc(squeeze(mean(sum(data,1),2)));
%%
figure; 
for uu=1:9; 
clf;
for ss=1:8; 
%     clf; 
subplot(2,4,ss)
    imagesc(squeeze(data(1:100,1:trialN(ss),uu,ss))'); 
    colormap gray; 
  
end;
  pause; 
end;


%% load info data

Dttls={'dissimilarities','2D distances','difference'};
Pttls={'MI (bits)', 'decoding (% correct)'};

I=nan(length(setList),length(TETA),length(TC));
I2Ddist=nan(size(I));
decperf=[];%nan(length(setList),length(TETA),length(TC));
decperf2Ddist=[];%nan(size(decperf));

for ff=1:length(setList)
    opts.set = setList{ff};
    disp(opts.set);
    
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'distmi');
    load(fullfile(dirName, fileName));
    
    I(ff,:,:)=distmi.I;
    I2Ddist(ff,:,:)=distmi.I2Ddist;
    decperf(ff,:,:,:)=distmi.decperf;
    decperf2Ddist(ff,:,:,:)=distmi.decperf2Ddist;
end;


%% plot information separately for each data set

figure;

ff=1;
opts.set = setList{ff};
disp(opts.set);
clf;

set(gcf,'pos',[342         484        1015         420]);

h(1)=subplot(1,2,1);
imagescnan(squeeze(mean(decperf(ff,:,:,:),4)));
set(gca,'ydir','normal','ytick',1:length(TETA),'yticklabel',num2str(TETA'),'xtick',1:length(TC),'xticklabel',num2str(TC'))
colorbar;
ylabel('teta','fontsize',16); xlabel('tc','fontsize',16);
title([Dttls{1} ': ' Pttls{2}],'fontsize',16);

h(2)=subplot(1,2,2);
imagescnan(squeeze(I(ff,:,:)));
set(gca,'ydir','normal','ytick',1:length(TETA),'yticklabel',num2str(TETA'),'xtick',1:length(TC),'xticklabel',num2str(TC'))
colorbar;
ylabel('teta','fontsize',16); xlabel('tc','fontsize',16);
title([Dttls{1} ': ' Pttls{1}],'fontsize',16);

if savefigs
    set(gcf,'color',[1 1 1]);
    fname=['dissim2DdistImage_' opts.set];
    export_fig(fullfile(dirs.plotdist,[fname '.eps']));
end;

%% plot % correct decoding 

figure;
for ii=1:length(TETA)
    for jj=1:length(TC)
        
        subplot(length(TETA),length(TC),jj+length(TC)*(ii-1));
        bar(squeeze(decperf(ff,length(TETA)-ii+1,jj,:)));
        ylim([0 100])
    end;
end;

%% plot 2D projection

% figure; set(gcf,'pos',[18         363        1636         533])
ff= 1;
MDScriterion={'metricstress','metricsstress','sammon','strain','sstress'};
% MDScriterion={'strain'};

opts.MDScriterion=MDScriterion{5};
ii=1;
jj=1;

%     for ii=1:length(TETA)
%         for jj=1:length(TC)
            
            clf;
            
            opts.set = setList{ff};
            disp(opts.set);

            [dirName, fileName] = file_opts_REPOSITORY(opts, 'distmi');
            load(fullfile(dirName, fileName));
            
            Y=squeeze(distmi.Y(ii,jj,:,:));
            trialN=distmi.trialN;
            nstim=length(trialN);
            RecPoinT0=nan(2,nstim);
            offset=1;
            for ss=1:nstim,
                Y2{ss}=Y(offset:offset+trialN(ss)-1,:);
                RecPoinT0(:,ss)=mean(Y2{ss},1);
                offset=offset+trialN(ss)-1;
            end;    
%             
%             % rescale positions to match the sensory field size
%             scalfact=3/4;
%             Xrange = 50*[-1 1];
%             Yrange = 50*[-1 1];
%             RecPoinT=(RecPoinT0./repmat(max(abs(RecPoinT0(:))),2,nstim)).*((scalfact)*repmat([Xrange(2); Yrange(2)],1,nstim));
%             
%             % find sensory regions by nearest neighbour method
%             TRI = delaunay(RecPoinT(1,:),RecPoinT(2,:));
%             ax=Xrange(1):.5:Xrange(2);
%             sensfield=nan(length(ax));
%             for x = 1:length(ax)
%                 for y = 1:length(ax)
%                     nearest = dsearch(RecPoinT(1,:),RecPoinT(2,:),TRI,ax(x),ax(y));
%                     sensfield(y,x)=nearest;
%                 end
%             end
%             
%             subplot(1,3,1);
%             bar(squeeze(distmi.decperf(ii,jj,:))); 
%             ylim([0 100]);
%             ylabel('% correct decoding')
%             
%             subplot(1,3,2)
            %
            figure
            cmap=jet(nstim);
            cmap=cmap(randperm(nstim),:);
            labz=num2str((1:length(trialN))');
            hold on;
            for ss=1:nstim,
                col=cmap(ss,:);
                plot(Y2{ss}(:,1),Y2{ss}(:,2),'o','color',col,'MarkerFaceColor',col);
%                 pause
            end;
            for ss=1:nstim,
                col=cmap(ss,:);
                plot(RecPoinT0(1,ss),RecPoinT0(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',10);
            end;
            legend(labz)
            title([strrep(setList{ff},'_','-') ' with teta=' num2str(TETA(ii)) ' and tc=' num2str(TC(jj)) 'ms'],'fontsize',12,'fontweight','bold')
                       %%
            subplot(1,3,3)
            imagesc(ax,ax,sensfield);
            colormap(cmap)
            set(gca,'ydir','normal')
            hold on;
            for ss=1:nstim,
                col=cmap(ss,:);
                plot(RecPoinT(1,ss),RecPoinT(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',14);
                text(RecPoinT(1,ss)-.7,RecPoinT(2,ss)-.4,num2str(ss),'fontsize',6,'fontweight','bold')
                %     pause;
            end;
            plotcircle(0,0,2);           
            
%             if savefigs
%                 set(gcf,'color',[1 1 1]);
%                 fname=['2DProj_' opts.set '_teta' num2str(TETA(ii)) '_tc' num2str(TC(jj))];
%                 export_fig(fullfile(dirs.plotdist,[fname '.eps']));
%             end;

%             pause;
%         end;
%     end;



%% see effect of MDS criterion

ff= 1;
ii=1;
jj=1;

figure;
%MDScriterion={'metricstress','metricsstress','sammon','strain','sstress'};
MDScriterion={'metricsstress','strain','sstress'};
% MDScriterion={'sammon','strain'};

for mm=1:length(MDScriterion)
    opts.MDScriterion=MDScriterion{mm};
    
    opts.set = setList{ff};
    disp(opts.set);
    
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'distmi');
    load(fullfile(dirName, fileName));
    
    Y=squeeze(distmi.Y(ii,jj,:,:));
    trialN=distmi.trialN;
    nstim=length(trialN);
    RecPoinT0=nan(2,nstim);
    offset=1;
    for ss=1:nstim,
        Y2{ss}=Y(offset:offset+trialN(ss)-1,:);
        RecPoinT0(:,ss)=mean(Y2{ss},1);
        offset=offset+trialN(ss)-1;
    end;
    
    % rescale positions to match the sensory field size
    scalfact=3/4;
    Xrange = 50*[-1 1];
    Yrange = 50*[-1 1];
    RecPoinT=(RecPoinT0./repmat(max(abs(RecPoinT0(:))),2,nstim)).*((scalfact)*repmat([Xrange(2); Yrange(2)],1,nstim));
    
    % find sensory regions by nearest neighbour method
    TRI = delaunay(RecPoinT(1,:),RecPoinT(2,:));
    ax=Xrange(1):.5:Xrange(2);
    sensfield=nan(length(ax));
    for x = 1:length(ax)
        for y = 1:length(ax)
            nearest = dsearch(RecPoinT(1,:),RecPoinT(2,:),TRI,ax(x),ax(y));
            sensfield(y,x)=nearest;
        end
    end
    
    
    subplot(2,length(MDScriterion),mm)
    cmap=jet(nstim);
    labz=num2str((1:length(trialN))');
    hold on;
    for ss=1:nstim,
        col=cmap(ss,:);
        plot(Y2{ss}(:,1),Y2{ss}(:,2),'o','color',col,'MarkerFaceColor',col);
    end;
    for ss=1:nstim,
        col=cmap(ss,:);
        plot(RecPoinT0(1,ss),RecPoinT0(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',10);
    end;
    if mm==length(MDScriterion), legend(labz); end;
    title(opts.MDScriterion)
    
    subplot(2,length(MDScriterion),length(MDScriterion)+mm)
    imagesc(ax,ax,sensfield);
    colormap(cmap)
    set(gca,'ydir','normal')
    hold on;
    for ss=1:nstim,
        col=cmap(ss,:);
        plot(RecPoinT(1,ss),RecPoinT(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',14);
        text(RecPoinT(1,ss)-.7,RecPoinT(2,ss)-.4,num2str(ss),'fontsize',6,'fontweight','bold')
        %     pause;
    end;
    plotcircle(0,0,2);
    
end;

%     title([strrep(setList{ff},'_','-') ' with teta=' num2str(TETA(ii)) ' and tc=' num2str(TC(jj)) 'ms'],'fontsize',12,'fontweight','bold')

%% new way of doing sensory regions

ff= 12;
ii=1;
jj=1;

figure;
%MDScriterion={'metricstress','metricsstress','sammon','strain','sstress'};
% MDScriterion={'sammon','strain'};
MDScriterion={'strain'};


mm=1;
% mm=3;
opts.MDScriterion=MDScriterion{mm};

opts.set = setList{ff};
disp(opts.set);

[dirName, fileName] = file_opts_REPOSITORY(opts, 'distmi');
load(fullfile(dirName, fileName));

Y=squeeze(distmi.Y(ii,jj,:,:));
trialN=distmi.trialN;
nstim=length(trialN);
decperf=squeeze(distmi.decperf(ii,jj,:));
% RecPoinT0=nan(2,nstim);
offset=1;
ncal=60;
Y2b=nan(nstim,ncal,2);
for ss=1:nstim,
%     Y2{ss}=Y(offset:offset+trialN(ss)-1,:);
    Y2b(ss,:,:)=Y(offset:offset+ncal-1,:);
%     RecPoinT0(:,ss)=mean(Y2{ss},1);
    offset=offset+trialN(ss)-1;
end;

% RecPoinT0=squeeze(mean(Y2b,2))';
% % rescale positions to match the sensory field size
% scalfact=3/4;
% Xrange = 50*[-1 1];
% Yrange = 50*[-1 1];
% RecPoinT=(RecPoinT0./repmat(max(abs(RecPoinT0(:))),2,nstim)).*((scalfact)*repmat([Xrange(2); Yrange(2)],1,nstim));

scalfactb=1*(max(Xrange)/max(abs(Y2b(:))));
Y2sc=scalfactb*Y2b;
RecPoinTsc=squeeze(mean(Y2sc,2))'; 

% find sensory regions by nearest neighbour method
TRI = delaunay(RecPoinTsc(1,:),RecPoinTsc(2,:));
ax=Xrange(1):.5:Xrange(2);
sensfield=nan(length(ax));
sensfieldb=nan(length(ax));
for x = 1:length(ax)
    for y = 1:length(ax)
        nearest = dsearch(RecPoinTsc(1,:),RecPoinTsc(2,:),TRI,ax(x),ax(y));
        sensfield(y,x)=nearest;
        
        % compute 2D distances
        Dtmp=nan(nstim,ncal);
        for ss=1:nstim,
%             for tt=1:ncal,
%                 Dtmp(ss,tt)=sqrt(sum(([ax(x);ax(y)]-squeeze(Y2sc(ss,tt,:))).^2));
%             end;
            Dtmp(ss,:)=sqrt(sum(([ax(x)*ones(ncal,1),ax(y)*ones(ncal,1)]-squeeze(Y2sc(ss,:,:))).^2,2));
        end;
%         z=-1;
        z=1;
        Dtravg=mean(Dtmp.^z,2).^(1/z); 
%         Dtravg=mean(abs(Dtmp),2); 
        [minstim, decostim]=min(Dtravg);
        sensfieldb(y,x)=decostim;
        
    end
end

            
subplot(2,2,1)
cmap=jet(nstim);
% labz=num2str((1:length(trialN))');
clear labz;
hold on;
for ss=1:nstim,
    col=cmap(ss,:);
%     plot(Y2{ss}(:,1),Y2{ss}(:,2),'o','color',col,'MarkerFaceColor',col);
%     plot(squeeze(Y2b(ss,:,1)),squeeze(Y2b(ss,:,2)),'o','color',col,'MarkerFaceColor',col);
    plot(squeeze(Y2sc(ss,:,1)),squeeze(Y2sc(ss,:,2)),'o','color',col,'MarkerFaceColor',col);
    labz{ss}=[num2str(ss) ' (' num2str(round(decperf(ss))) '%)'];
%     pause
end;

% if mm==length(MDScriterion), legend(labz); end;
xlim(Xrange); ylim(Yrange);
for ss=1:nstim,
    col=cmap(ss,:);
    plot(RecPoinTsc(1,ss),RecPoinTsc(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',18);
    text(RecPoinTsc(1,ss)-.7,RecPoinTsc(2,ss)-.4,[num2str(round(decperf(ss))) '%'],'fontsize',8,'fontweight','bold')
end;
title(opts.MDScriterion)

subplot(2,2,2)
%
edges{1}=-max(abs(Y(:))):.5:max(abs(Y(:)));
edges{2}=edges{1};
[N,C]=hist3(fliplr(Y),'Edges',edges);
pcolor(C{1},C{2},N);
% colormap hot;
shading interp;
hold on;
offset=1;
for ss=1:nstim,
    [N,C]=hist3(fliplr(Y(offset:offset+ncal-1,:)),'Edges',edges);
    contour(C{1},C{2},N,1,'col',cmap(ss,:),'linewidth',3);
    offset=offset+trialN(ss)-1;
% %     pause
end;
%
subplot(2,2,3)
imagesc(ax,ax,sensfield);
colormap(cmap)
set(gca,'ydir','normal')
hold on;
for ss=1:nstim,
    col=cmap(ss,:);
    plot(RecPoinTsc(1,ss),RecPoinTsc(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',14);
    text(RecPoinTsc(1,ss)-.7,RecPoinTsc(2,ss)-.4,num2str(ss),'fontsize',6,'fontweight','bold')
    %     pause;
end;
plotcircle(0,0,2);

subplot(2,2,4)
imagesc(ax,ax,sensfieldb);
% colormap(cmap)
set(gca,'ydir','normal')
hold on;
for ss=1:nstim,
    col=cmap(ss,:);
    plot(RecPoinTsc(1,ss),RecPoinTsc(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',14);
    text(RecPoinTsc(1,ss)-.7,RecPoinTsc(2,ss)-.4,num2str(ss),'fontsize',6,'fontweight','bold')
    %     pause;
end;
plotcircle(0,0,2);


