dirs = dir_opts_REPOSITORY;
% dirfigs='/media/WDDATA/BMIproject_svn/documentation/reports/Jun2012/';

ax=-50:5:50;
ax_hd=-50:.5:50;

%%
[X,Y] = meshgrid(ax);
K=4;
Fx=-K*X; Fy=-K*Y;

[X_hd,Y_hd] = meshgrid(ax_hd);
Fx_hd=-K*X_hd; Fy_hd=-K*Y_hd;

%%

attpos=[10; 0];
attsigma=(3/4)*max(ax);
attint=0.2*(282.8427/0.0343);

reppos=[-10; 0];
repsigma=attsigma/2;
repint=-2*attint/3;

gauss=@(P,targ,sigma)(exp(-((P-targ)'*(P-targ))/sigma^2)/sigma^2);
Fgauss=@(P,targ,sigma,int)(int*-2*(P-targ)*gauss(P,targ,sigma));
Pdip=@(P,attpos,attsigma,attint,reppos,repsigma,repint)(attint*gauss(P,attpos,attsigma)+repint*gauss(P,reppos,repsigma));
Fdip=@(P,attpos,attsigma,attint,reppos,repsigma,repint)(Fgauss(P,attpos,attsigma,attint)+Fgauss(P,reppos,repsigma,repint));
% Felas=@(P,K)(-K*P);

X=zeros(length(ax));
Y=zeros(length(ax));
Fx=zeros(length(ax));
Fy=zeros(length(ax));

F=nan(2,length(ax),length(ax));
for xi=1:length(ax)
    x=ax(xi);
    for yi=1:length(ax)
        y=ax(yi);
        
        P=[x; y];
        
%         G=exp(-((P-targ)'*(P-targ))/sigma^2);
%         Ftmp=-2*(P-targ)*G/sigma^2;
%         Ftmp=Int*Fgauss(P,sigma,targ)+Int2*Fgauss(P,sigma2,targ2);
        Ftmp=Fdip(P,attpos,attsigma,attint,reppos,repsigma,repint);
%         Ftmp=Felas(P,K);
        
        Fx(xi,yi)=Ftmp(1);
        Fy(xi,yi)=Ftmp(2);
        X(xi,yi)=x;
        Y(xi,yi)=y;
    end;
end;

X_hd=zeros(length(ax_hd));
Y_hd=zeros(length(ax_hd));
Fx_hd=zeros(length(ax_hd));
Fy_hd=zeros(length(ax_hd));
F_hd=nan(2,length(ax_hd),length(ax_hd));
Pdip_hd=nan(length(ax_hd),length(ax_hd));

for xi=1:length(ax_hd)
    x=ax_hd(xi);
    for yi=1:length(ax_hd)
        y=ax_hd(yi);
        
        P=[x; y];
        
%         G=exp(-((P-targ)'*(P-targ))/sigma^2);
%         Ftmp=-2*(P-targ)*G/sigma^2;
%         Ftmp=Fgauss(P,sigma,targ);
%                 Ftmp=Int*Fgauss(P,sigma,targ)+Int2*Fgauss(P,sigma2,targ2);
        Ftmp=Fdip(P,attpos,attsigma,attint,reppos,repsigma,repint);
Pdip_hd(xi,yi)=Pdip(P,attpos,attsigma,attint,reppos,repsigma,repint);
%         Ftmp=Felas(P,K);
        
        Fx_hd(xi,yi)=Ftmp(1);
        Fy_hd(xi,yi)=Ftmp(2);
        X_hd(xi,yi)=x;
        Y_hd(xi,yi)=y;
    end;
end;
% 
% Fx=(282.8427/0.0343)*Fx;
% Fy=(282.8427/0.0343)*Fy;
% Fx_hd=(282.8427/0.0343)*Fx_hd;
% Fy_hd=(282.8427/0.0343)*Fy_hd;

%%
figure; 
% imagesc(ax,ax,sqrt(Fx_hd.^2+Fy_hd.^2)'); 
imagesc(ax,ax,Pdip_hd'); 
caxis(0.8*max(abs(caxis))*[-1 1]); colorbar;
set(gca,'ydir','normal'); %colormap hot;
% fname='FFMag';
% set(gcf, 'PaperPositionMode', 'auto')
% saveas(gcf,fullfile(dirfigs,[fname '.png']));
% plot2svg(fullfile(dirfigs,[fname '.svg']))

%
% figure;  
hold on;
h=quiver(X,Y,Fx,Fy);
axis square
set(h,'linewidth',1,'color','k');
% axis off
% set(gca,'xtick',[],'ytick',[])
set(gcf,'color',[1 1 1])

% fname='FF';
% set(gcf, 'PaperPositionMode', 'auto')
% % saveas(gcf,fullfile(dirfigs,[fname '.png']));
% plot2svg(fullfile(dirfigs,[fname '.svg']))
