clear; clc;

opts.algo = 'algo2c';
opts.rec='recsim2DM1_20ms';
opts.cal='cal1';
opts.dynSys = 'dynSys_damp13';

getSim2DM1SetList;

ff=1;

opts.set = setList{ff};
[dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
load(fullfile(dirName, fileName));  % load data and dataParams;

avgspknb=squeeze(mean(sum(data,1),2));
nstims=size(avgspknb,2);
nbel=sqrt(size(avgspknb,1));

figure; colormap gray;
for ss=1:nstims
    % spike mean in each electrode
    subplot(3,4,ss);
    avgspknbtmp=reshape(avgspknb(:,ss),[nbel nbel]);
    imagesc(avgspknbtmp);
    set(gca,'ydir','normal','xtick',[],'ytick',[])
    caxis([0 8]);
    ptmp=get(gca,'pos');
    ptmp(2)=ptmp(2)-.05;
    set(gca,'pos',ptmp);
    title(['stim ' num2str(ss)])
%     pause
end;

    ptmp=get(gca,'pos');
    colorbar
    set(gca,'pos',ptmp);

fname=['AvgSpkNb_' opts.set '.svg'];
% plot2svg(['/media/TOSHDATA_/BMIproject_svn/documentation/reports/Apr2012/' fname])

%%
figure; imagesc(reshape(1:nstims',[sqrt(nstims) sqrt(nstims)])');
set(gca,'xtick',[],'ytick',[])
fname=['AvgSpkNb_' opts.set 'StimColor.svg'];
plot2svg(['/media/TOSHDATA_/BMIproject_svn/documentation/reports/Apr2012/' fname])

%%
% -------------------------
% load results of the calibration
% -------------------------
uu = 1;
ii = 1; % bin size
jj = 1; % window size
kk = 1; % offset
[dirName, fileName] = file_opts_REPOSITORY(opts, 'cal');
load(fullfile(dirName, fileName), 'cal');

% units=cal.units{uu};
% RecPoint=squeeze(cal.RecPoint(uu,jj,kk,ii,:,:));
% RecForce=squeeze(cal.RecForce(uu,jj,kk,ii,:,:));
% ForceCal=squeeze(cal.ForceCal(uu,jj,kk,ii,:,:,:));
% ForceTest=squeeze(cal.ForceTest(uu,jj,kk,ii,:,:,:));
% ntrials=cal.testntrials;

dispfield=cal.dispfield{uu,jj,kk,ii};
Y2=dispfield.Y2;
RecPoinT=dispfield.RecPoinT;
RecPoinT2=dispfield.RecPoinT2;
ax=dispfield.ax;
sensfield=dispfield.sensfield;

nstim=size(RecPoinT2,2);

algo2_opts = algo2_opts_REPOSITORY(opts.algo);
scalfact=algo2_opts.scalfact;

%%
cmap=jet(nstim);
figure;
subplot(1,2,1);
hold on;
for ii=1:nstim,
    col=cmap(ii,:);
    plot(squeeze(Y2(:,ii,1)),squeeze(Y2(:,ii,2)),'o','color',col,'MarkerFaceColor',col, 'MarkerEdgeColor','k');
%     pause;
end;

RecPoinT0=squeeze(mean(Y2,1))';
for ii=1:nstim,
    col=cmap(ii,:);
    plot(RecPoinT0(1,ii),RecPoinT0(2,ii),'s','color','k','MarkerFaceColor',col,'MarkerSize',16);
    text(RecPoinT0(1,ii)-.7,RecPoinT0(2,ii)-.4,num2str(ii),'fontsize',8,'fontweight','bold','color','k')

end;

axis(50*[-1 1 -1 1])

subplot(1,2,2);%
imagesc(ax,ax,sensfield);
set(gca,'ydir','normal')
hold on;

% for ii=1:nstim,
%     col=cmap(ii,:);
%     plot(squeeze(Y2(:,ii,1))-dispfield.CenterPoint(1),squeeze(Y2(:,ii,2))-dispfield.CenterPoint(2),'o','color',col,'MarkerFaceColor',col, 'MarkerEdgeColor','k');
% end;

for ii=1:nstim,
    col=cmap(ii,:);
    plot(RecPoinT(1,ii),RecPoinT(2,ii),'s','color','k','MarkerFaceColor',col,'MarkerSize',16);
    text(RecPoinT(1,ii)-.7,RecPoinT(2,ii)-.4,num2str(ii),'fontsize',8,'fontweight','bold','color','k')
end;
plotcircle(0,0,2);


% RecPoinT0=squeeze(mean(Y2,1))';
% for ii=1:nstim,
%     col=cmap(ii,:);
%     plot(RecPoinT0(1,ii)-dispfield.CenterPoint(1),RecPoinT0(2,ii)-dispfield.CenterPoint(2),'s','color','k','MarkerFaceColor',col,'MarkerSize',10);
% end;

set(gcf,'pos',[75         316        1413         562])
fname=['sensreg_' opts.set '_' opts.algo '.svg'];
plot2svg(['/media/TOSHDATA_/BMIproject_svn/documentation/reports/Apr2012/' fname])
