% Plot both the calibration outcome and the trajectories obtained during
% simulation

setrootdir;
% getsetList;
% 
% opts.rec = 'rec0bin';
% opts.cal='cal1';
% opts.algo = 'algo1';
% opts.dynSys = 'dynSys1';
% opts.sim = 'sim1';

getSimMixSetList;

opts.cal='cal1';
opts.algo = 'algo1';
opts.rec='recsimmix';
opts.dynSys='dynSys_damp13';
opts.sim = 'sim2';

% -------------------------
% load sampling parameters
% -------------------------
rec_opts = rec_opts_REPOSITORY(opts.rec);
BIN = rec_opts.bin;
WINDOW = rec_opts.window;
OFFSET = rec_opts.offset;

% -------------------------
% select data set
% -------------------------
ff=1; %28:31
opts.set = setList{ff};

% -------------------------
% load calibration file
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'cal');
load(fullfile(dirName, fileName));
ntrials=cal.testntrials;

% -------------------------
% load simulation file
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
load(fullfile(dirName, fileName));

% -------------------------
% PLOT 
% -------------------------
uu = 1; % set of SUs
ii = 1; % bin
jj = 1; % window
kk = 1; % offset

figure;
for ii=1:length(BIN)
% load data
ForcesCal=squeeze(cal.ForceTest(uu,jj,kk,ii,:,:,:));
RecPts=double(squeeze(cal.RecPoint(uu,jj,kk,ii,:,:)));
RecF=squeeze(cal.RecForce(uu,jj,kk,ii,:,:));

Pos=squeeze(sim.State(uu,jj,kk,ii,:,:,1:2));
Converge=squeeze(sim.Converge(uu,jj,kk,ii,:));
% percentage of convergences
nbconv=round(100*sum(~isnan(Converge))/length(Converge));
% mean number of steps to convergence (when it does)
nbstp=round(mean(Converge(~isnan(Converge))));
titstr=[opts.set '. window=' num2str(WINDOW(jj)) 'ms' '. offset=' num2str(OFFSET(kk)) 'ms .' 'bin=' num2str(BIN(ii)) 'ms. '];

subplot(1,2,1); cla
% figure;
plotCalibration(RecPts,RecF,ForcesCal,ntrials);
xlim([-8 8]); ylim([-8 8])
title(titstr);

% figure;
subplot(1,2,2); cla
plotTrajectories(Pos,[]);
title([num2str(nbconv) '% convergences in ' num2str(nbstp) ' steps']);
axis square;

[ax,h]=suplabel(titstr  ,'t');
set(h,'FontSize',20)
pause
end;