% Marianna Semprini & Fran�ois Szymanski
% IIT, July 2010

setrootdir;
getsetList;

opts.rec = 'rec1';
opts.cal='cal1'; uu=1;
opts.algo = 'algo1';
opts.dynSys = 'dynSys1';

% -------------------------
% load sampling parameters
% -------------------------
rec_opts = rec_opts_REPOSITORY(opts.rec);
BIN = rec_opts.bin;
WINDOW = rec_opts.window;
OFFSET = rec_opts.offset;
% -------------------------

fl_mean = zeros(length(setList),length(BIN),length(WINDOW),length(OFFSET));
fl_std = zeros(length(setList),length(BIN),length(WINDOW),length(OFFSET));

for ff=1:length(setList)
    opts.set = setList{ff};
    disp(opts.set);
    
    % -------------------------
    % load simulation file
    % -------------------------
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'cal');
    load(fullfile(dirName, fileName));
    ntrials=cal.testntrials;
    
    for ii = 1:numel(BIN)
        for jj = 1:numel(WINDOW)
            for kk = 1:numel(OFFSET);
                
                Forcestmp = squeeze(cal.ForceTest(uu,jj,kk,ii,:,:,:));
                Forces=nan(sum(ntrials),2);
                offset=0;
                for ss=1:length(ntrials),
                    Forces(offset+1:offset+ntrials(ss),:)=squeeze(Forcestmp(1:ntrials(ss),ss,:));
                    offset=offset+ntrials(ss);
                end;
                
                forceL = sqrt(Forces(:,1).^2 + Forces(:,2).^2);
                
                fl_mean(ff,ii,jj,kk)=nanmean(forceL);
                fl_std(ff,ii,jj,kk)=nanstd(forceL);
                
            end
        end
    end;
end;


%%
jj=1; kk=1;
figure
boxplot(squeeze(fl_mean(:,:,jj,kk)));