% Marianna Semprini & Fran�ois Szymanski
% IIT, July 2010

setrootdir;
getsetList;

opts.rec = 'rec1';
opts.cal='cal1'; uu=1;
opts.algo = 'algo1';
opts.dynSys = 'dynSys1';
opts.sim = 'sim1';

for ff=1:length(setList)
    opts.set = setList{ff};
    disp(opts.set);
    
    % -------------------------
    % load calib file
    % -------------------------
    [dirName, fileName] = file_opts_REPOSITORY(opts, 'cal');
    load(fullfile(dirName, fileName));
    ntrials=cal.testntrials;
    nStim=length(ntrials);
    
    % -------------------------
    % load sampling parameters
    % -------------------------
    rec_opts = rec_opts_REPOSITORY(opts.rec);
    BIN = rec_opts.bin;
    WINDOW = rec_opts.window;
    OFFSET = rec_opts.offset;
    % -------------------------
    
    for ii = 1:numel(BIN) 
        for jj = 1:numel(WINDOW)   
            for kk = 1:numel(OFFSET);  
                               
                Forces = shiftdim(squeeze(cal.ForceTest(uu,jj,kk,ii,:,:,:)),2);
                recForce = squeeze(cal.RecForce(uu,jj,kk,ii,:,:)); 
                                                
                absCal = abs(recForce(:,1)+recForce(:,2)*1i);
                absForce= squeeze(abs(Forces(1,:,:) + Forces(2,:,:)*1i));
                        
                figure(100)
                
                for ll = 1:nStim
                    diffAngle = acos((recForce*squeeze(Forces(:,1:ntrials(ll),ll)))./(absCal*absForce(1:ntrials(ll),ll)'));
                    [closeststim tmp]=find(diffAngle==repmat(min(diffAngle,[],1),[nStim 1]));
                    subplot(2,2,ll)
                    rose(diffAngle(ll,:));
                end
                
                pause
            end
        end
    end
end