
setrootdir;
getsetList;

% opts.rec = 'rec1';
opts.rec = 'rec0bin';
opts.cal='cal1';
opts.algo = 'algo1';
opts.dynSys = 'dynSys1';
opts.sim = 'sim1';

% -------------------------
% load sampling parameters
% -------------------------
rec_opts = rec_opts_REPOSITORY(opts.rec);
BIN = rec_opts.bin;
WINDOW = rec_opts.window;
OFFSET = rec_opts.offset;
% -------------------------

% ff = 1; % data set
uu = 1; % set of units
% ii = 1; % bin
jj = 1; % window
kk = 1; % offset

% MIFopt = {'FxFy0','RT0','AC0'}; infotyp='infoForceFromTraj';
MIFopt = {'FxFy1','RT1','AC1'}; infotyp='infoForce';

MIforce=nan(length(setList),length(BIN),length(MIFopt));
for mm=1:length(MIFopt)
    
    opts.MIForce = MIFopt{mm};
    
    for ff=1:length(setList)
        
        % -------------------------
        % select data set
        % -------------------------
        opts.set = setList{ff};
        
        % -------------------------
        % load I(F,Fexp)
        % -------------------------
        [dirName, fileName] = file_opts_REPOSITORY(opts, infotyp);
        load(fullfile(dirName, fileName));  % load I and Ibtsp
        
        MIforce(ff,:,mm)=squeeze(I(uu,jj,kk,:));
        
    end;
end;


%% get rid of bad data
% [a b]=find(squeeze(MIForce(:,:,1))>0.1);
[a b]=find(reshape(MIforce,[length(setList) numel(BIN)*length(MIFopt)])>-2);
idx=unique(a);
size(MIforce,1)-length(idx)


%% -------------------------
% plot performance
% -------------------------

figure;
set(gcf,'pos',[76         298        1590         580])

maxI=0.8*max(MIforce(:));

for mm=1:3,
    
    MIf=squeeze(MIforce(idx,:,mm));
    
    h(1,mm)=subplot(3,3,[mm 3+mm]);
    imagesc(MIf)
    set(gca,'xtick',1:numel(BIN),'xticklabel',num2str(BIN'))
    ylabel('data set');
    colorbar;
    caxis([0 maxI])
    title(MIFopt{mm})
    
    h(2,mm)=subplot(3,3,6+mm);
    errorbar(nanmean(MIf,1),nanstd(MIf,[],1)/sqrt(length(BIN)))
    set(gca,'xtick',1:numel(BIN),'xticklabel',num2str(BIN'))
%     ylim([0 .4*maxI])
    xlabel('bin (ms)'); ylabel('bits')
end;

% beautify
for ii=1:3,
    p1=get(h(1,ii),'pos');
    p2=get(h(2,ii),'pos');
    p2(3)=p1(3);
    set(h(2,ii),'pos',p2)
end;