
setrootdir;
getsetList;
savefigs=0;

opts.rec = 'rec0offwin';
opts.cal='cal1';
opts.algo = 'algo1';
opts.dynSys = 'dynSys1';
opts.sim = 'sim1';

% -------------------------
% load sampling parameters
% -------------------------
rec_opts = rec_opts_REPOSITORY(opts.rec);
BIN = rec_opts.bin;
WINDOW = rec_opts.window;
OFFSET = rec_opts.offset;
% -------------------------

% ff = 1; % data set
uu = 1; % set of units
ii = 1; % bin
% jj = 1; % window
% kk = 1; % offset

MIFopt = {'FxFy0','RT0','AC0'}; infotyp='infoForceFromTraj';
% MIFopt = {'FxFy1','RT1','AC1'}; infotyp='infoForce';

MIForceLabels = {'I(S; [Fx,Fy]) [bit]', 'I(S;[\rho, \theta]) [bit]',  'I(\Thetaexp; \Theta) [bit]'};

MIforce=nan(length(setList),length(WINDOW),length(OFFSET),length(MIFopt));
for mm=1:length(MIFopt)
    
    opts.MIForce = MIFopt{mm};
    
    for ff=1:34 %length(setList)
        
        % -------------------------
        % select data set
        % -------------------------
        opts.set = setList{ff};
        
        % -------------------------
        % load I(F,Fexp)
        % -------------------------
        [dirName, fileName] = file_opts_REPOSITORY(opts, infotyp);
        load(fullfile(dirName, fileName));  % load I and Ibtsp
        
        MIforce(ff,:,:,mm)=squeeze(I(uu,:,:,:));
        
    end;
end;


%% get rid of bad data

% rmcond='all'; idxrem=[];
% rmcond='maxCR50'; idxrem=[2     5    10    17    18];             
rmcond='maxCR60'; idxrem=[2     5    10    11    12    15    16    17    18    27];   
% rmcond='maxMIFxFy04'; idxrem=[2     3     5     6    18];
% rmcond='maxMIteta01'; idxrem=[2     3     5    10    11    12    14   18]; 

idxkeep=setdiff(1:length(setList),idxrem);

% -------------------------
% plot performance
% -------------------------

MIavg=squeeze(nanmean(MIforce(idxkeep,:,:,:),1));

figure;
set(gcf,'pos',[68         407        1557         425])

maxI=max(MIavg(:));
cxis=[.20 .45; .20 .45; 0 .10];
for mm=1:3,
    
    MIf=squeeze(MIavg(:,:,mm));
    
    h(1,mm)=subplot(1,3,mm);
  
    imagescnan(MIf)
    
    set(gca,'xtick',1:numel(OFFSET),'xticklabel',num2str(OFFSET'),'ytick',1:numel(WINDOW),'yticklabel',num2str(WINDOW'),'ydir','normal')
    xlabel('offset [ms]'); 
    ylabel('window duration [ms]');
    colorbar;
%     caxis(cxis(mm,:))
    title(MIForceLabels{mm})  
end;

if savefigs
    set(gcf,'color',[1 1 1])
    fname=['MIwinoffset_' opts.algo '_' opts.dynSys '_' opts.sim '_' rmcond];
    dirs = dir_opts_REPOSITORY;
    export_fig(fullfile(dirs.plotPerfMI,[fname '.eps']));
    saveas(gcf,fullfile(dirs.plotPerfMI,fname),'fig');
    close;
end;