clear; clc;

% getsetList;
getSimulatedSetList;

opts.rec = 'rec1';
opts.info= 'mi1';

% -------------------------
% load sampling parameters
% -------------------------
rec_opts = rec_opts_REPOSITORY(opts.rec);
BIN = rec_opts.bin;
WINDOW = rec_opts.window;
OFFSET = rec_opts.offset;
% -------------------------

ff = 1; % data set
uu = 1; % set of units
% ii = 1; % bin
jj = 1; % window
kk = 1; % offset


% -------------------------
% select data set
% -------------------------
opts.set = setList{ff};

% -------------------------
% load SU info
% -------------------------
[dirName, fileName] = file_opts_REPOSITORY(opts, 'MI stim SU');
load(fullfile(dirName, fileName));  % load I and Ibtsp
MISU=squeeze(I(:,jj,kk,:));
nbSU=size(MISU,1);

%% -------------------------
% plot performance
% -------------------------

figure;
set(gcf,'pos',[143   472   557   383])

maxI=1.5*max(MISU(:));

h(1)=subplot(3,1,[1 2]);
imagesc(MISU)
set(gca,'xtick',1:numel(BIN),'xticklabel',num2str(BIN'))
ylabel('SU');
colorbar;
caxis([0 maxI])

h(2)=subplot(3,1,3);
errorbar(mean(MISU,1),std(MISU,[],1)/sqrt(length(BIN)))
set(gca,'xtick',1:numel(BIN),'xticklabel',num2str(BIN'))
ylim([0 maxI/2])
xlabel('bin (ms)'); ylabel('bits')

% beautify
p1=get(h(1),'pos');
p2=get(h(2),'pos');
p2(3)=p1(3);
set(h(2),'pos',p2)
