clear; clc;
dirs = dir_opts_REPOSITORY;
% savefigs=1;
dirfigs='/media/TOSHDATA/BMIproject_svn/documentation/2012-08/';
%~~~~~~~~~~~~~~~~~
% lists of options
%~~~~~~~~~~~~~~~~~
% getsetList;
% getSimMixSetList;
% getSetListMomo;
getSim2DM1SetList;

% algos={'algo1','algo2a_ScaleYtoField','algo2c'};
% algos={'algo1','algo2a_ScaleYtoFieldNoShift','algo2c_ScaleYtoFieldNoShift'};
% algos={'algo1','algo2a_ScaleYtoFieldNoShiftS','algo2c_ScaleYtoFieldNoShiftS'};
algos={'algo2a0_ScaleYtoFieldNoShiftS','algo2s_ScaleYtoFieldNoShiftS'};

recs={'recsimmix','recsim2DM1','recsim2DM1_20ms','recsim2DM1_120ms'};
cals={'cal1_mindecod50b','cal1','cal1_min6stimsdecthres20','cal30'};
dynSys={'dynSys_damp13','dynSys_damp19','dynSys_damp25','dynSys_damp31','dynSys_damp37','dynSys1','dynSys_Gauss','dynSys_Dipole'};
simopt={'sim2','sim5'};

%%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% select from lists of options
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

% % ffs=3:-1:1;
% % rrs=[4 4 3];

ffs=1:10;
rrs=(zeros(10)+4)';
% 
% ffs=1:4;
% rrs=[4 4 4 4];

dds=[7 8];
aas=[1 2];

% ff=2;
% aa = 1;
% rr = 4;
cc = 4;
% dd = 7;
ss = 2;

ntraj=320;
dmall=nan(ntraj,length(ffs),length(dds),length(aas));
dmallinv=nan(size(dmall));

for ffi = 1:length(ffs);
    ff=ffs(ffi);
    rr=rrs(ffi);
    for ddi = 1:length(dds);
        dd=dds(ddi);
        for aai = 1:length(aas);
            aa=aas(aai);
            
            %~~~~~~~~~~~~~~~~~~~~
            % set opts structure
            %~~~~~~~~~~~~~~~~~~~~
            opts.set = setList{ff};
            opts.algo = algos{aa};
            opts.rec = recs{rr};
            opts.cal= cals{cc};
            opts.dynSys= dynSys{dd};
            opts.sim = simopt{ss};
            
            uu = 1; % set of SUs
            ii = 1; % bin
            jj = 1; % window
            kk = 1; % offset
            
            %~~~~~~~~~~~~~~~~~~~~
            % LOAD CORRESPONDING DATA
            %~~~~~~~~~~~~~~~~~~~~
            % -------------------------
            % load parameters
            % -------------------------
            rec_opts = rec_opts_REPOSITORY(opts.rec);
            BIN = rec_opts.bin;
            WINDOW = rec_opts.window;
            OFFSET = rec_opts.offset;
            
            dynSys_opts = dynSys_opts_REPOSITORY(opts.dynSys);
            Xrange = dynSys_opts.Xrange;
            Yrange = dynSys_opts.Yrange;
            Radius = dynSys_opts.radius;
            
            % -------------------------
            % load simulation file
            % ------------------------- 
            [dirName, fileName] = file_opts_REPOSITORY(opts, 'sim');
            load(fullfile(dirName, fileName));
            PerfLabel = {'rate of convergences', 'number of steps to convergence'};
            Converge = squeeze(sim.Converge(uu,jj,kk,ii,:));
            nbconv =round(100*sum(~isnan(Converge(:)))/length(Converge(:)));
            nbstp =round(mean(Converge(~isnan(Converge))));
            TestState=squeeze(sim.State(uu,jj,kk,ii,:,:,:));
            
            [dirName, fileName] = file_opts_REPOSITORY(opts, 'sim_idealFF');
            load(fullfile(dirName, fileName));
            Converge = sim.Converge;
            nbconv0 =round(100*sum(~isnan(Converge(:)))/length(Converge(:)));
            nbstp0 =round(mean(Converge(~isnan(Converge))));
            TestState0=sim.State;
            
            % distance point by point between ideal and actual trajectories
            dpp=sqrt(sum((TestState(:,:,1:2)- TestState0(:,:,1:2)).^2,3));
            % average distances between ideal and actual trajectories
            dm=mean(dpp,2);
            dmall(:,ffi,ddi,aai)=dm;
%             dmallinv(:,ffi,ddi,aai)=1./dm;
        end;
    end;
end;

dmavg=squeeze(mean(dmall,1));
dmstderr=squeeze(std(dmall,0,1))/sqrt(ntraj);

dmmed=squeeze(median(dmall,1));
dmiq=quantile(dmall,[.25 .75],1);

%%
datatit={'Gaussian FF','Dipole FF'};
algtit={'decoding algo','sandro version'};

figure; set(gcf,'pos',[218   422   920   459])

for ddi = 1:length(dds);
    dd=dds(ddi);
    
    subplot(1,2,ddi);
    
     bar(squeeze(dmavg(:,ddi,:))); hold on;
    
    
%      bar(squeeze(dmmed(:,ddi,:))); hold on;
       %errorbar((1:length(aas))+.15,nbstpavg(:,ffi),nbstpstd(:,ffi),'rx',dmavg)'linewidth',2)
%      errorbar([(1:length(ffs))'-.15, (1:length(ffs))'+.15],squeeze(mean(dmiq(:,:,ddi,:))),squeeze(diff(dmiq(:,:,ddi,:),1))/2,'r.','linewidth',2)
        errorbar([(1:length(ffs))'-.15, (1:length(ffs))'+.15],squeeze(dmavg(:,ddi,:)),dmstderr(:,:,ddi,:),'r.','linewidth',2)

%             

%     ylim([0 1.24])
ylim([0 30])
% ylim([0 .8])

    title([datatit{ddi}],'fontweight','bold','fontsize',14)
    
    grid on;
    set(gca,'fontsize',12,'fontweight','bold')
    
%      set(gca,'xticklabel',{'8','32','128'})
%     set(get(gca,'xlabel'),'string','Nb of stims in the data set','fontweight','bold','fontsize',14)
%   set(gca,'xticklabel',{'normal','broken rec. el. 1','broken stim. el. 1'})
     set(gca,'xticklabel',{'0','10','20','30','40','50','60','70','80','90'})

%     rotateticklabel(gca,20);
%     set(get(gca,'xlabel'),'string','Nb of stims in the data set','fontweight','bold','fontsize',14)
    set(get(gca,'xlabel'),'string','gamma (%)','fontweight','bold','fontsize',14)
    
    set(get(gca,'ylabel'),'string','error','fontweight','bold','fontsize',14)
    
end;

legend({'decoding algo','sandro version'})
%%
fname='Perfs_robust_brokenel';
set(gcf, 'PaperPositionMode', 'auto')
saveas(gcf,fullfile(dirfigs,[fname '.png']));