%% plot average number of spikes recorded with the 2DM1 simulated data
%
%% NOTE:call from MAIN_plot_script.m

%remove the "_gammaxx" at the end of the set name to get the sim2DM1_opts
tmp=regexp(opts.set,'_');
tmpsim2DM1opts=opts.set(1:tmp(end)-1);

sim2DM1_opts = sim2DM1_opts_REPOSITORY(tmpsim2DM1opts);

ds=sim2DM1_opts.ds;
stimspread=sim2DM1_opts.stimspread;
maxavgspknb=sim2DM1_opts.maxavgspknb;
nbbarrels=sim2DM1_opts.nbbarrels;
dr=sim2DM1_opts.dr;
nbel=sim2DM1_opts.nbel;
stimspacing=sim2DM1_opts.stimspacing;
stimposX=sim2DM1_opts.stimposX;
stimposY=sim2DM1_opts.stimposY;
elspacing=sim2DM1_opts.elspacing;
elposX=sim2DM1_opts.elposX;
elposY=sim2DM1_opts.elposY;
avgspknb=sim2DM1_opts.avgspknb;
%%
for mm=length(maxavgspknb)
    
    figure(mm); clf;
    figure(mm+10); clf;
    
    for ss=1:length(stimposX(:))
        
        % select one stimulus
        stim=[stimposX(ss) stimposY(ss)];
        
        % spike probabilities with overlayed electrode positions
        figure(mm); 
%         subplot(length(stimspacing),length(stimspacing),ss);
        subplot(3,3,ss);
        ax=min([elspacing(1) stimspacing(1)]):(dr/10):max([elspacing(end) stimspacing(end)]); [X,Y]=meshgrid(ax,ax);
        g=maxavgspknb(mm)*gaussian(X,Y,stim,stimspread);
        imagesc(ax,ax,g);
        colorbar; hold on; title(['stimulus' num2str(ss)]);
        set(gca,'ydir','normal')
        plot(elposX(:),elposY(:),'ow'); % plot electrodes
        caxis([0 max(maxavgspknb)]);
        
        % spike probabilities in each electrode
        figure(mm+10); 
%         subplot(length(stimspacing),length(stimspacing),ss);
        subplot(3,3,ss);
        avgspknb=maxavgspknb(mm)*gaussian(elposX,elposY,stim,stimspread);
        imagesc(elspacing,elspacing,avgspknb);
        colorbar; title(['stimulus' num2str(ss)]);
        set(gca,'ydir','normal')
        caxis([0 max(maxavgspknb)]);
    end;
end;