clear; clc;
% dirs = dir_opts_REPOSITORY;

% getsetList;
% getSimMixSetList;
getSim2DM1SetList;
% getSetListMomo;

ff=1;

% opts.dist='dist_120ms';
opts.dist='dist2';

% MDScriterion={'metricstress','metricsstress','sammon','strain','sstress'};
MDScriterion={'strain'};

opts.MDScriterion=MDScriterion{1};
dist_opts = dist_opts_REPOSITORY(opts.dist);
TETA = round(180*dist_opts.teta/pi);
TC = dist_opts.tc;

% load data 
opts.set = setList{ff};
% [dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
% load(fullfile(dirName, fileName));  % load data and dataParams;

% [dirName, fileName] = file_opts_REPOSITORY(opts, 'dist');
% load(fullfile(dirName, fileName));

[dirName, fileName] = file_opts_REPOSITORY(opts, 'distmi');
load(fullfile(dirName, fileName));

% % get distances
ii=1; jj=1;
% D=squeeze((dist.D(ii,jj,:,:)));

% extract positions from MDS
Y=squeeze(distmi.Y(ii,jj,:,:));
trialN=distmi.trialN;

nstim=length(trialN);
RecPoinT0=nan(2,nstim);
offset=1;

%used for alternative way of doing sensory regions
ncal=trialN(1);
Y2b=nan(nstim,ncal,2);
% D2=nan(nstim,ncal,nstim*ncal);

for ss=1:nstim,
    Y2{ss}=Y(offset:offset+trialN(ss)-1,:);
    Y2b(ss,:,:)=Y(offset:offset+ncal-1,:);
    RecPoinT0(:,ss)=mean(Y2{ss},1);
%     D2(ss,:,:)=D(offset:offset+ncal-1,:);
    offset=offset+trialN(ss);
end;

%% plot average data

figure, imagesc(squeeze(mean(sum(data,1),2)));

%% plot distances
figure;
ss=76; % 5 9 11 13
imagesc(squeeze(D2(ss,1:end,:)));

    
%% plot decoding performances    
figure; plot(squeeze(distmi.decperf))
hold on; plot(squeeze(distmi.decperf2Ddist),'r')
title('Decoding performances (%)')
legend({['all dim (I=' num2str(distmi.I) 'bits)'],['2D (I=' num2str(distmi.I2Ddist) 'bits)']})
xlabel('stimulus')


%% plot 2D projection

cmap=jet(nstim);
% cmap=cmap(randperm(nstim),:);
% labz=num2str((1:length(trialN))');

figure
hold on;
for ss=1:nstim,
    col=cmap(ss,:);
    plot(Y2{ss}(:,1),Y2{ss}(:,2),'o','color',col,'MarkerFaceColor',col);
    title(num2str(ss))
%                     pause()
end;
for ss=1:nstim,
    col=cmap(ss,:);
    plot(RecPoinT0(1,ss),RecPoinT0(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',5);
end;
% legend(labz)

title([strrep(setList{ff},'_','-') ' with teta=' num2str(TETA(ii)) ' and tc=' num2str(TC(jj)) 'ms'],'fontsize',12,'fontweight','bold')


%%  plot sensory regions

% find sensory regions by nearest neighbour method
Xrange=1*max(abs(RecPoinT0(:)))*[-1 1];
TRI = delaunay(RecPoinT0(1,:),RecPoinT0(2,:));
ax=Xrange(1):.1:Xrange(2);
sensfield=nan(length(ax));
for x = 1:length(ax)
    for y = 1:length(ax)
        nearest = dsearch(RecPoinT0(1,:),RecPoinT0(2,:),TRI,ax(x),ax(y));
        sensfield(y,x)=nearest;
    end
end

figure;
imagesc(ax,ax,sensfield);
colormap(cmap)
set(gca,'ydir','normal')
hold on;
for ss=1:nstim,
    col=cmap(ss,:);
    plot(RecPoinT0(1,ss),RecPoinT0(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',5);
    %     pause;
end;

title([strrep(setList{ff},'_','-') ' with teta=' num2str(TETA(ii)) ' and tc=' num2str(TC(jj)) 'ms'],'fontsize',12,'fontweight','bold')


%% new way of doing sensory regions

RecPoinTb=squeeze(mean(Y2b,2))'; 

% find sensory regions by nearest neighbour method
Xrange=1*max(abs(RecPoinT0(:)))*[-1 1];
TRI = delaunay(RecPoinT0(1,:),RecPoinT0(2,:));
ax=Xrange(1):.05:Xrange(2);
sensfield=nan(length(ax));
sensfieldb=nan(length(ax));
for x = 1:length(ax)
    for y = 1:length(ax)
        nearest = dsearch(RecPoinTb(1,:),RecPoinTb(2,:),TRI,ax(x),ax(y));
        sensfield(y,x)=nearest;
        
        % compute 2D distances
        Dtmp=nan(nstim,ncal);
        for ss=1:nstim,
            Dtmp(ss,:)=sqrt(sum(([ax(x)*ones(ncal,1),ax(y)*ones(ncal,1)]-squeeze(Y2b(ss,:,:))).^2,2));
        end;
%         z=-1;
        z=1;
        Dtravg=mean(Dtmp.^z,2).^(1/z); 
        [minstim, decostim]=min(Dtravg);
        sensfieldb(y,x)=decostim;
    end
end

%
figure;
cmap=jet(nstim);
cmap=cmap(randperm(nstim),:);
subplot(1,2,1)
imagesc(ax,ax,sensfield);
colormap(cmap)
set(gca,'ydir','normal')
hold on;
for ss=1:nstim,
    col=cmap(ss,:);
    plot(RecPoinTb(1,ss),RecPoinTb(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',10);
end;

subplot(1,2,2)
imagesc(ax,ax,sensfieldb);
set(gca,'ydir','normal')
hold on;
for ss=1:nstim,
    col=cmap(ss,:);
    plot(RecPoinTb(1,ss),RecPoinTb(2,ss),'s','color','k','MarkerFaceColor',col,'MarkerSize',10);
end;


