%% plot average number of spikes recorded with the 2DM1 simulated data
%
%% NOTE:call from MAIN_plot_script.m

[dirName, fileName] = file_opts_REPOSITORY(opts, 'raw mat');
load(fullfile(dirName, fileName));  % load data and dataParams;

avgspknb=squeeze(mean(sum(data,1),2));
nstims=size(avgspknb,2);
nbel=sqrt(size(avgspknb,1));

ncols=8;
nrows=ceil(nstims/ncols);
figure; colormap gray;
for ss=1:nstims
    % spike mean in each electrode
    subplot(nrows,ncols,ss);
    avgspknbtmp=reshape(avgspknb(:,ss),[nbel nbel]);
    imagesc(avgspknbtmp);
    set(gca,'ydir','normal','xtick',[],'ytick',[])
    caxis([0 40]);
    ptmp=get(gca,'pos');
    ptmp(2)=ptmp(2)-.01;
    set(gca,'pos',ptmp);
    title(['stim ' num2str(ss)])
    %     pause
end;

ptmp=get(gca,'pos');
colorbar
set(gca,'pos',ptmp);

% fname=['AvgSpkNb_' opts.set '.svg'];
% plot2svg(['/media/TOSHDATA_/BMIproject_svn/documentation/reports/Apr2012/' fname])
