
tPos=squeeze(TestState(:,:,1:2));
% tF=squeeze(TestForce(:,:,1:2));

% [gainF, maxF] = SetForceGraphics(Xrange, Yrange, dynSys_opts.stiffness);
nRun=size(tPos,1);

figure;
% for each run of the simulation
for rr = 1:nRun
    clf;
    
    if exist('sensfield','var')
        imagesc(ax,ax,sensfield)
    end;
    set(gca,'ydir','normal');
    hold on;
    
    title(['run ' num2str(rr)])
    plot([0 0],[0 0],'x');
    
    plotcircle(0,0,2);
    hold on;
    
    % plot symbols for the beginning and end of the trajectory
    plot(squeeze(tPos(rr,1,1)), squeeze(tPos(rr,1,2)),'dg','linewidth',2)
    
    % plot mass position and force applied at each simulation step (typ 1s)
    for kk = 1:min([size(tPos,2)-1 Converge(rr)])-1
        
        % NOTE: the point mass is at position k after applying force k
        Pi = squeeze(tPos(rr,kk,:));
        Pe = squeeze(tPos(rr,kk+1,:));
%         Fg = gainF.*squeeze(tF(rr,kk+1,:));
%         p = arrw([Pi(1), Pi(2)]', [Pi(1)+Fg(1), Pi(2)+Fg(2)]');
        
        % plot trajectory
        
        plot(Pi(1), Pi(2),'ok','linewidth',2);
        %         pause(.5)
        %
        %         plot(p(1,:), p(2,:), 'r');
        %         pause(.5)
        
        plot([Pi(1) Pe(1)], [Pi(2) Pe(2)],'g-','linewidth',2)
        xlim(Xrange);
        ylim(Yrange);
        
        pause(.05)
    end
    
    plot(squeeze(tPos(rr,end,1)), squeeze(tPos(rr,end,2)),'dr','linewidth',2)
    
%     reply = input('input sth if you want it to stop: ', 's');
%     if ~isempty(reply)
%         break;
%     end
    
    %     pause;
end;


% %%
% if savefigs
%     set(gcf,'color',[1 1 1]);
%     fname='alltraj';
%     export_fig(fullfile(dirs.plotsimmix,[fname '.eps']));
% end;