function plotCalibration(RecPts,RecF,Forces,ntrials)
% Plot Force vectors from the test set at the location corresponding to the
% stimulus that elicited them

nstim=length(ntrials);
[gainF, maxF] = SetForceGraphics([-10, 10], [-10, 10], -[4 0; 0 4]);

hold on;

% title(['bin=' num2str(BIN(ii)) 'ms'])

% for each stimulus
for ss=1:nstim,
    % plot each of the corresponding forces from the Test set
    for tt=1:ntrials(ss),
        Fg = gainF.*squeeze(Forces(tt,ss,:));
        %         p = arrw([RecPts(1,ss), RecPts(2,ss)]', [RecPts(1,ss)+Fg(1), RecPts(2,ss)+Fg(2)]');
        p = arrw([RecPts(ss,1), RecPts(ss,2)]', [RecPts(ss,1)+Fg(1), RecPts(ss,2)+Fg(2)]');
        plot(p(1,:), p(2,:), 'k');
    end;
end;

% for each stimulus
for ss=1:nstim,
    % plot average force from the Training Set
    Fg=0.2*RecF(ss,:);
    %     p = arrw([RecPts(1,ss), RecPts(2,ss)]', [RecPts(1,ss)+Fg(1), RecPts(2,ss)+Fg(2)]');
    p = arrw([RecPts(ss,1), RecPts(ss,2)]', [RecPts(ss,1)+Fg(1), RecPts(ss,2)+Fg(2)]');
    plot(p(1,:), p(2,:), 'b','linewidth',3);
    
    % plot average force from the Test Set
    F = 0.2*squeeze(nanmean(Forces(:,ss,:),1));
    Fg=F;
    %     p = arrw([RecPts(1,ss), RecPts(2,ss)]', [RecPts(1,ss)+Fg(1),
    %     RecPts(2,ss)+Fg(2)]');
    p = arrw([RecPts(ss,1), RecPts(ss,2)]', [RecPts(ss,1)+Fg(1), RecPts(ss,2)+Fg(2)]');
    plot(p(1,:), p(2,:), 'r','linewidth',3);
end;

%     % plot triangulation
%     TRI = delaunay(RecPts(:,1),RecPts(:,2));
%     triplot(TRI,RecPts(:,1),RecPts(:,2),'k');

% plotcircle(0,0,2);
plotcircle(0,0,8);
axis square;
axis equal;
