function plotSparseFieldData(Point, Force, gain, maxf, stepColor)
%
% plot a sparse vecor field.

[dim, ndata] = size(Point);
if nargin<5
    stepColor = 'b';
end
for ii=1:ndata
    if (abs(Force(1)) <= maxf) && (abs(Force(2)) <= maxf)
        vx = gain * Force(1, ii);
        vy = gain * Force(2, ii);
        % (much slower!)		arrow([x(i,j), y(i,j)], [x(i,j)+vx,y(i,j)+vy]);
        plotarrw([Point(1, ii), Point(2, ii)]', [Point(1, ii)+vx, Point(2, ii)+vy]', stepColor);
        plot(Point(1, ii), Point(2, ii), 'k.');
    end
end