function plot_InterpolatedField(Xrange, Yrange, RecPoint, Force, ntrials, TRI, gainF, maxF)
% function plotFragmenteField plot the force field obtained
% from a preparation with background noise

% Force is obtained from cal.ForceTest by taking a particular combination
% of dataset (number of units), window, offset and bin

[nTrial, nStim, NComp] = size(Force);
colorCode = ['r' 'c' 'g' 'b']';
% colorCode = [0 0 1; 1 0 0; .1 .5 .1; 0.7 0.6 0];

% figure;
hold on;

x = 0;
y = 0;
for ii = Xrange(1):2:Xrange(2)
    x = x+1;
    for jj = Yrange(1):2:Yrange(2)
        y = y+1;
        nearest = dsearch(RecPoint(1,:),RecPoint(2,:),TRI,ii,jj);
        
        % stimulate and record
        index = ceil(rand*(ntrials(nearest)));
        F = squeeze(Force(index,nearest,:));
               
        PlotSparseFieldData([ii,jj]', F, gainF, maxF, colorCode(nearest,:));
        
    end
end
% triplot(handles.TRI,handles.RecPoint(1,:),handles.RecPoint(2,:),'k');

axis square;
axis auto;
axis equal;